{
  TUTOR4.PAS

  shows simple animation of an sonic
}

uses dos, crt, _VidKRNL, _VID10E, _XLSP10E;

var
  sonicGFX : array[1..4] of TSprite; { this is a array of sprites }
  titleGFX : TXLSprite;              { just another sprite, but a XL with more than 64KBytes }
  sonicPAL : TPal;                   { this is a 256 color palette }
  page1    : TPage10Eh;              { this is a virtual page }

  x,y        : integer; { needed for the sonic position      }
  phase      : byte;    { current animation phase ( 1 to 4 ) }
  phaseDelay : byte;    { how often shall each phase drawn, before
                          switching to the next one }
  actDelay   : byte;    { how often is the current phase shown? }

  b : byte; { just needed for the loading and closing the sprites }

{ Have a look at the online manual of Turbo/Borland Pascal (Keyword: STR)
  Converts any integer type to a string }
function IntToStr( HelpInt : LongInt ): string;
var
  HelpString : string;
begin
  Str( HelpInt , HelpString );
  IntToStr := HelpString;
end;

begin
  { initialise the Video10Eh variables. Call this procedure first }
  InitVideo10Eh;

  loadPalette('.\PAL\SONIC.PAL',sonicPAL);        {loads a palette}

  { Load SONIC1's to the array }
  for b := 1 to 4 do
    LoadImprocesCLB( '.\GFX\SONIC1-' + IntToStr( b ) + '.CLB', sonicGFX[ b ], sonicPAL );

  { loads TITLE1.CLB to the titleGFX sprite }
  LoadXLImprocesCLB( '.\TITLE\TITLE1.CLB', titleGFX, sonicPAL);

  { initialise the Page1 }
  InitPage10Eh( Page1 );

  { switch on the 320x200x64k Mode }
  SetVideoMode10Eh( Mode10Eh );

  { all outputs go now to Page1, our first virtual page }
  ActivePage10EH( Page1 );

  { initialise the sonic position and animation values }
  x := 0;
  y := 0;
  phase      := 1; { current animation phase is 1 }
  phaseDelay := 5; { new animation phase after 5 frames }
  actDelay   := 0; { the current animation phase had been drawn, 0 times }

  repeat
    { Clears the Page Page1; fills it with 0's }
    ClearPage10Eh(Page1);

    { draws the sprite titleGFX to screenposition 0,0 }
    PutXLSpriteWindow10Eh( 0, 0, titleGFX );
    { draws the sprite sonicGFX to Screenposition x,y }
    PutSpriteWindowTrans10Eh( x, y, 0, sonicGFX[phase] );

    { wait for a verticale retrace of the monitor;
      use this to make smooth scrolling and flicker free animations }
    Retrace;

    { copy the virtual Page Page1 to the VisualPage; also posssible would
      be CopyP2P10Eh ( Page1, VisualPage ) }
    CopyP2V10Eh( Page1 );

    if x < 319 then { let the sonic doing some movements }
        inc( x, 5 )
      else
        begin
          x := 0;
          inc( y, 5 );
        end;
    if y > 199 then y := 0;

    { check, if we have to take the next animation phase }
    if actDelay < phaseDelay then
        inc( actDelay ) { no, just increment the delay-Counter }
      else
        begin
          actDelay := 0;  { yes, take the next animation phase }

          { animation reached the end? }
          if phase < 4 then
              inc( phase ) { take the next animation phase }
            else
              phase := 1; { start animation from beginning }
        end;

  until keypressed; { wait for a key pressed }

  { gives the page memory back to system }
  ClosePage10Eh(Page1);

  { gives the sprite memory back to system }
  for b := 1 to 4 do CloseSprite( sonicGFX[ b ] );
  CloseXLSprite ( titleGFX );

  { switch back to normal text mode 80x25 }
  SetVideoMode10Eh( Mode3h );

  { Closes the Video10Eh. Should be the last instruction in your programm }
  CloseVideo10Eh;
end.