{
  _VIDEO10E.PAS 320x200x64K

  (c) vIRTUAL tECHNOLOGIES 1996

  Version 1.0b

  for more information, questions and register contact us:

    Ansgar Scherp
    scherp.ansgar@informatik.uni-oldenburg.de

    Joachim Gelhaus
    j.gelhaus@flight.gun.de

    http://www.informatik.uni-oldenburg.de/~virtech/

    Mailbox : + 49 (0) 4441 / 851887
    Hotline : + 49 (0) 4441 / 851717 (english, german)


  Remember, that in HiColor-Modes like 640x480x64K there are no longer
  any stuff like palettes. You can just put the color to the screen
  you want.

  If you already know our 256-Color units, you might miss the routines
  ending with 'eff'. They were totally renamed and don't have the
  appendix 'eff' longer.

}

{DEFINE ShareWare}

{$IFNDEF DPMI}
...no, only for protected mode
{$ENDIF}

unit _Vid10E;

interface

uses _VidKRNL,crt;

type
  TPage10Eh = array[0..9] of pointer;

const
  mode10Eh : word = $10E; { the mode 320x200x64k }

{ initialise/close Video13hSystem }
procedure InitVideo10Eh;
procedure CloseVideo10Eh;

{ set the ActivePage, on which you want to draw }
procedure ActivePage10Eh(var page : TPage10Eh);

{ set a video mode; mode10Eh ($110) is for VESA-SVGA-Mode 320x200x32k }
procedure SetVideomode10Eh(m:word);

{ set window-edges of ActivePage }
procedure SetWindow10Eh(x1,y1,x2,y2:longint);

{ display an error message }
procedure Video10EhError(t:string);

{ copy a virtual screen to another virtual screen }
procedure CopyP2P10Eh(var Src,Dst:TPage10Eh);
{ copy a virtual screen to visual screen }
procedure CopyP2V10Eh(VAR page:TPage10Eh);

{ clears a virtual screen }
procedure ClearPage10Eh( page:TPage10Eh);
{ clears the visual page }
procedure ClearVisualPage10Eh;

{ initialies a new virtual page }
procedure InitPage10Eh(var page:TPage10Eh);
{ closes a virtual page }
procedure ClosePage10Eh(var page:TPage10Eh);

{ puts/gets a pixel directly to/from visual screen }
procedure DirectPutPixel10Eh(x,y : integer; c : word);
function  DirectGetPixel10Eh(x,y:integer):word;

{ puts/gets a pixel to/from current active virtual screen }
procedure PutPixel10Eh(x,y:integer; c:word);
function  GetPixel10Eh(x,y:integer ) : word;

{ draws a line to current active virtual screen }
procedure Line10Eh( x1, y1, x2, y2 : Integer; color : word);

{ puts sprites to current active virtual screen }
procedure PutSpriteWindow10Eh(x,y:integer; p: TSprite );
procedure PutSpriteWindowTrans10Eh(x,y:integer; trans:word;p: TSprite );
procedure PutSpriteWindowShadow10Eh(x,y:integer; SubR, SubG, SubB : byte; p: TSprite );
procedure PutSpriteWindowLight10Eh(x,y:integer; AddR, AddG, AddB : byte; p: TSprite );
procedure PutSpriteWindowMix10Eh(x,y:integer; p: TSprite );
procedure PutSpriteWindowAdd10Eh(x,y : integer; p : TSprite);

{ puts/gets a pixel to/from current active virtual screen /
  looking for window-borders;  }
procedure PutPixelWindow10Eh(x,y : longint; c :word);
function  GetPixelWindow10Eh(x,y : longint):word;

{ draws an filled rectangle on the current virtual screen }
procedure RectangleWindow10Eh(x1,y1,x2,y2,x3,y3,x4,y4:longint; c : word);
{ draws an filled triangle on the current virtual screen }
procedure TriangleWindow10Eh(x1,y1,x2,y2,x3,y3:longint; c : word);
{ draws a line on the current virtual screen }
procedure LineWindow10Eh( x1, y1, x2, y2 : longint; color : word );

{ gets a sprite from screen }
procedure GetSprite10Eh(x,y:integer; p: TSprite );

{
  No, this source is not free now!
  For register the unit or getting the source code, please contact us.
 }

{Hier sind die SCALING Routinen}
{$IFNDEF ShareWare}
procedure PutSpriteScaled10Eh(x,y,dx,dy:integer; p: TSprite );
procedure PutSpritePerCent10Eh(x,y:integer; factor:real; p : tsprite);
procedure PutSpriteScaledTrans10Eh(x,y,dx,dy:integer; Tcol:word; p: Tsprite );
procedure PutSpritePerCentTrans10Eh(x,y:integer; factor:real; Tcol:word; p : TSprite );
{$ENDIF}

implementation

uses _DPMI{$IFNDEF ShareWare}, _BigLoad{$ENDIF};

{Die wirkliche Scale-routine}
{$F+}
{$L _SCALE3.OBJ}
{$L _SCALE4.OBJ}
procedure _Scale1( X,Y,DW,DY,SW,SH:integer;Bitmap:pointer); external;
procedure _Scale1Trans( X,Y,DW,DY,SW,SH:integer; Bitmap:pointer ); external;
{$F-}

var
  FreeMemory : longint;

type
  modes   = array[0..255] of word;
  p_modes = ^modes;
  asciiz   = array[0..255] of char;
  p_asciiz = ^asciiz;

  vesainfotype =
    record
      signature    : array[0..3] of char; {VESA}
      version      : array[0..1] of byte;
      OEMName      : p_asciiz; { Hersteller }
      capabilities : array[0..3] of byte;
      vmodes       : p_modes;
      reserved     : array[0..237] of byte;
    end;

  modeinfotype =
    record
      attributes       : word;
      winA             : byte;
      winB             : byte;
      granularity      : word; { KB-increment for moving windows }
      size             : word; { in KB }
      segA             : word; { segmant of winA }
      segB             : word;
      eqv4f05          : longint;
      bytesperscanline : word; { optional, siehe at_optional_available }
      width            : word;  { Breite in Pixeln }
      height           : word; { Hhe in Pixeln }
      characterwidth   : byte; { Zeichenbreite }
      characterheight  : byte; { Zeichenhhe }
      planes           : byte; { BitPlanes }
      bitsperpixel     : byte;
      banks            : byte;
      memorymodel      : byte;
      sizeofbank       : byte; { in KB }
      numberOfImagePages:byte;
      reserved         : byte; {should be 1}
      RedMaskSize       :byte; { size of direct color red mask in bits}
      RedFieldPosition  :byte; { bit position of LSB of red mask    }
      GreenMaskSize     :byte; { size of direct color green mask in bits}
      GreenFieldPosition:byte; { bit position of LSB of green mask       }
      BlueMaskSize      :byte; { size of direct color blue mask in bits   }
      BlueFieldPosition :byte; { bit position of LSB of blue mask          }
      RsvdMaskSize      :byte; { size of direct color reserved mask in bits }
      DirectColorModeInfo:byte;{ Direct Color mode attributes}
      res              : array[0..256-$28] of byte; { Auffller zu 256 Bytes }
    end;

var
  Page10Eh      : TPage10Eh;
  VisualPage10Eh : TPage10Eh;
  ActVPage10Eh   : TPage10Eh; {Auf diesen pointer beziehen sich alle Grafikroutinen}
  Regs           : TRealModeRegs;
  LowMemoryBlock : TLowMemoryBlock; { ACHTUNG: Wird global benutzt! }
  VesaInfo       : vesainfotype;
  ModeInfo       : modeinfotype;
  Granny         : byte;
  BankNr         : byte;
  WinX1,WinX2,
  WinY1,WinY2    : integer; {globale Vars! Grenzen des sichtfensters! }

const
  Windows10Eh : array[0..1,1..4] of integer = ((0,319,0,99),
                                               (0,319,0,99));

{ Have a look at the online manual of Turbo/Borland Pascal (Keyword: STR)
  Converts any integer type to a string }
function IntToStr( HelpInt : LongInt ): string;
var
  HelpString : string;
begin
  Str( HelpInt , HelpString );
  IntToStr := HelpString;
end;

procedure SetVideomode10Eh(m:word);
begin
  regs.ax:=$4f02;
  Regs.bx:=m;
  if SimRealModeInt($10,Regs)=false then
  begin
    writeln(GetSimRealModeIntError);
    halt(0);
  end;
end;

function GetPage(x,y : integer):byte;
begin
  if y <=99 then GetPage := 0 else GetPage :=1;
end;

function CalcPageX(x:integer;b:word):integer;
begin
  CalcPageX := x;
end;

function CalcPageY(y:integer;b:word):integer;
begin
  asm
    cmp b,0
    jz @ende
    sub y,100 {page 1}
    @ende:
  end;
  CalcPageY := y
end;

function CheckInArea(bank:byte;x,y:longint;p: TSprite):byte;
var breite,tiefe : integer;
    ltrag,otrag,rtrag,utrag : integer;
    b:byte;
begin
  SetWindow(Windows10Eh[bank,1],Windows10Eh[bank,3],Windows10Eh[bank,2],Windows10Eh[bank,4]);
  {damit auf zeile 199 und spalte 319 auch gezeichnet wird}
  inc(wx2); inc(wy2);
  {betrge berechnen}
  if x < wx1 then ltrag := wx1-x else ltrag := 0;
  if y < wy1 then otrag := wy1-y else otrag := 0;
  if x+p.b > wx2 then rtrag := x+p.b-wx2 else rtrag := 0;
  if y+p.t > wy2 then utrag := y+p.t-wy2 else utrag := 0;
  {und weg damit wieder!!!}
  dec(wx2); dec(wy2);
  {reale breite und tiefe ermitteln}
  breite := p.b - ltrag - rtrag;
  tiefe := p.t - otrag - utrag;
  {wenn kleiner oder gleich Null, dann raus}
  {Das Sprite ist in dem Fenster ...}
  if (breite < p.b) or (tiefe < p.t) then b:=1; {teileweise zu sehen}
  if (breite = p.b) and (tiefe = p.t) then b:=2; {komplett drin}
  if (breite <= 0)   or (tiefe <= 0)  then b:=0; {nicht drin}
  setwindow(0,0,319,99);
  CheckInArea := b;
end;

procedure SetWindow10Eh(x1,y1,x2,y2:longint);
  var h : longint;
      bank:byte;
      rx1,rx2,ry1,ry2:integer;
begin
  if x1 < 0 then x1 := 0;
  if x1 > 319 then x1 := 319;
  if y1 < 0 then y1 := 0;
  if y1 > 199 then y1 := 199;
  if x1 > x2 then begin h := x2; x2 := x1; x1 := h; end;
  if y1 > y2 then begin h := y2; y2 := y1; y1 := h; end;

  WinX1 := x1; WinX2 := x2; WinY1 := y1; WinY2 := y2;

  for bank:=0 to 1 do begin
    rx1:=CalcPageX(x1,bank); ry1:=CalcPageY(y1,bank);
    rx2:=CalcPageX(x2,bank); ry2:=CalcPageY(y2,bank);
    setwindow(rx1,ry1,rx2,ry2);
    if (wx1=wx2) or (wy1=wy2) then
      begin
        wx1:=0; wx2:=0; wy1:=0; wy2:=0;
      end;
    windows10Eh[bank,1]:=wx1; windows10Eh[bank,2]:=wx2;
    windows10Eh[bank,3]:=wy1; windows10Eh[bank,4]:=wy2;
  end;
end;

procedure SetBank(b:byte);
begin
  regs.ax:=$4f05;
  Regs.bx:=$0000;
  Regs.dx:=b*granny;
  SimRealModeInt($10,Regs);
  regs.ax:=$4f05;
  Regs.bx:=$0001;
  Regs.dx:=b*granny;
  SimRealModeInt($10,Regs);
  banknr:=b;
end;

procedure GetVESAInfo;
var bes,bdi,bcx:word;
    bah,bal:byte;
    x:word;
    segment,offset:word;
begin
  AllocateLowMem( LowMemoryBlock ,300);
  ClearRealRegs(regs);
  Regs.es:=LowMemoryBlock.RealModeSeg;
  Regs.ax:=$4f00;
  if SimRealModeInt($10,Regs)=false then
    begin
      writeln(GetSimRealModeIntError);
      halt(0);
    end;
  for x:=0 to sizeof(vesainfo)-1 do mem[seg(vesainfo):ofs(vesainfo)+x]:=mem[LowMemoryBlock.ProtModeSel:x];
  FreeLowMem(LowMemoryBlock);
end;

procedure GetModeInfo(m:word);
var bes,bdi,bcx:word;
    bah,bal:byte;
    x:word;
    segment,offset:word;
begin
  AllocateLowMem(LowMemoryBlock,300);
  ClearRealRegs(regs);
  Regs.es:=LowMemoryBlock.RealModeSeg;
  Regs.cx:=m;
  Regs.ax:=$4f01;
  if SimRealModeInt($10,Regs)=false then
    begin
      writeln(GetSimRealModeIntError);
      halt(0);
    end;
  for x:=0 to sizeof(modeinfo)-1 do mem[seg(modeinfo):ofs(modeinfo)+x]:=mem[LowMemoryBlock.ProtModeSel:x];
  FreeLowMem(LowMemoryBlock);
  granny:=64 div modeinfo.granularity;
end;

procedure InitVideo10Eh;
var ch:char;
    b:byte;
begin
  Page10Eh[0]       := ptr(SegA000,0);
  VisualPage10Eh[0]  := ptr(SegA000,0);

  SetWindow10Eh(0,0,319,199);
  {Check if VESA is available}
  GetVESAInfo;
  if vesainfo.Signature='VESA' then writeln('VESA VBE      : found!');
  if vesainfo.Signature<>'VESA' then writeln('VESA VBE      : not found!');
  if vesainfo.Signature<>'VESA' then
    begin
      writeln('Please install VBE VESA-driver and run again.');
      halt(1);
    end;
  {VESA is available, so check mode-specific stuff}
  GetModeInfo(Mode10Eh);
  writeln('Granularity   : ',ModeInfo.granularity,' KBytes');
  writeln('Bytes per Scan: ',ModeInfo.bytesperscanline);
  writeln('Width         : ',ModeInfo.width);
  writeln('Height        : ',ModeInfo.height);
  writeln('SegA          : ',ModeInfo.sega);
  writelN('MemoryModel   : ',ModeInfo.memorymodel);
  writeln('DirectColMoInf: ',ModeInfo.directColorModeInfo);
  if (modeInfo.Attributes and 1)=0 then begin
    writeln('Your graphic card does not supported 320x200x32k VideoMode 10Eh');
    writeln('Better by a new card');
    writeln('Please contact the author');
    delay(500);
{    halt(1);}
  end;
  if (ModeInfo.memoryModel)<>6 then begin
    writeln('Your graphic card does not support the DIRECT COLOR MODEL');
    writeln('Please try to start from plain DOS');
    writeln('Or contact the author (or by a new graphic board)');
    delay(500);
{    halt(1);}
  end;
{  if (ModeInfo.directColorModeInfo and 2)=0 then begin
    writeln('Application is not allowed to use the reserved 16''th bit');
    writeln('Please try to start from plain DOS');
    writeln('Or contact the author');
    halt(1);
  end;}
  FreeMemory := MemAvail;
end;

procedure CloseVideo10Eh;
begin
  SetVideomode10Eh(Mode3h);
  if FreeMemory <> MemAvail then begin
      writeln('MemoryManagement-error detected:');
      writeln('We have a memory-difference of totally '+
              inttostr(FreeMemory-MemAvail)+' bytes!'+#7);
     halt(2);
   end;
end;

procedure Video10EhError(t:string);
begin
  SetVideomode10Eh(mode3h);
  writeln('Video10EhSystemError at: ');
  writeln(t);
  halt(1);
end;

procedure ActivePage10Eh(var page : TPage10Eh);
var b:byte;
begin
  ActVPage10Eh:=page;
end;

procedure CopyLines( s1,o1,s2,o2:word; off:word; lines:byte); assembler;
asm
  push ds
    mov al,lines
    mov es,SEGA000; mov di,off
    mov si,o1; mov dx,o2
    mov ds,s1; mov bx,s2

    @loop1:
    mov cx,160;{ shr cx,2}
    db $66; rep movsw
    xchg si,dx
    push ds
    mov ds,bx
    pop bx

    mov cx,160;{ shr cx,2}
    db $66; rep movsw
    xchg si,dx
    push ds
    mov ds,bx
    pop bx

    dec al
    cmp al,0
    jnz @loop1
  pop ds
end;

procedure CopyDWord(dstoffset,srcsegment,srcoffset,l:word); assembler;
asm
  push ds
    mov es,SEGA000
    mov di,dstoffset
    mov ds,srcsegment
    mov si,srcoffset
    mov cx,l
    shr cx,2
    db $66; rep movsw
  pop ds
end;

{fertig fr 64k Farben gendert}
procedure copyP2V10Eh(VAR page:TPage10Eh);
var s0,s1:word;
begin
  s0 := seg(page[0]^);
  s1 := seg(page[1]^);

  setbank(0);
  copyDword(00000,s0,0,640*100); {0-99}
  copyDword(64000,s1,0,1536);
  setbank(1);
  copyDword(0,s1,1536,64000-1536);{}
end;

{fertig fr 64k Farben gendert}
procedure CopyP2P10Eh(var Src,Dst:TPage10Eh); {DWORD-VERSION // ab 386er}
var b:byte;
    s,d:pointer;
begin
  asm push ds end;
  for b := 0 to 1 do begin
    s:=src[b];
    d:=dst[b];
    ASM
      les di, s
      lds si, d
      mov cx, 16000
      db $66; rep movsw
    end;
    end;
  asm pop ds end;
END;

{fertig fr 64k Farben gendert}
procedure ClearPage10Eh( page:TPage10Eh); {DWORD-VERSION // ab 386er}
var b:byte;
    p:pointer;
begin
  for b:=0 to 1 do begin
    p:=page[b];
    asm
      les di, p
      {les di, dword ptr page[1]}
      db $66; xor ax,ax
      mov cx,64000 / 4
      db $66; rep stosw
    end;
  end;
end;

{fertig fr 64k Farben gendert}
procedure ClearVisualPage10Eh; {DWORD-VERSION // ab 386er}
var b:byte;
begin
  for b:=0 to 1 do begin
    setbank(b);
    asm
      mov es,SegA000
      xor di,di
      db $66; xor ax,ax
      mov cx,65536 / 4
      db $66; rep stosw
    end;
  end;
end;

{fertig fr 64k Farben gendert}
procedure InitPage10Eh(var page:TPage10Eh);
var b:byte;
    w:word;
begin
  for b:=0 to 1 do
    begin
      if (page[b] <> NIL) then
        Video10EhError('Trying to open an already existing page!');
      InitPage(Page[b]);
    end;
  ActivePage10Eh(page);
end;

{fertig fr 64k Farben gendert}
procedure ClosePage10Eh(var page:TPage10Eh);
var b:byte;
begin
  for b:=0 to 1 do begin
    if page[b] = NIL then Video10EhError('Trying to close an already closed page!');
    ClosePage(Page[b]);
  end;
end;

{fertig fr 64k Farben gendert}
procedure DirectPutPixel10Eh(x,y : integer; c : word);
var off,b:word;
begin
  asm
    mov ax,640
    mov bx,y
    mul bx    { DX enthlt die oberen 4 Bit der Multiplikation also alles ber 65535}
    add ax,x
    add ax,x
    jnc @noverflow
    inc dx
    @noverflow:
    mov off,ax
    mov b,dx
  end;
  if banknr<>b then setbank(b);
  memw[segA000:off]:=c;
end;

{fertig fr 64k Farben gendert}
Function DirectGetPixel10Eh(x,y:integer):word;
var off,b:word;
begin
  asm
    mov ax,640
    mov bx,y
    mul bx    { DX enthlt die oberen 4 Bit der Multiplikation also alles ber 65535}
    add ax,x
    jnc @noverflow
    inc dx
    @noverflow:
    mov off,ax
    mov b,dx
  end;
  if banknr<>b then setbank(b);
  DirectGetPixel10Eh:=memw[segA000:off];
end;

{fertig fr 64k Farben gendert}
procedure PutPixel10Eh(x,y:integer; c:word);
var page:word;
begin
  page := GetPage(x,y);
  ActVPage := ActVPage10Eh[page];
  PutPixel(x, y mod 100,c);
end;

{fertig fr 64k Farben gendert}
function GetPixel10Eh(x,y:integer ) : word;
var page:word;
begin
  page := GetPage(x,y);
  ActVPage := ActVPage10Eh[page];
  GetPixel10Eh := GetPixel(x,y mod 100);
end;

{fertig fr 64k Farben gendert}
PROCEDURE Line10Eh( x1, y1, x2, y2 : Integer; color : word );{ Bresenham line }
VAR j, steps, sx, sy, dx, dy, e : Integer;
    steep : Boolean;
BEGIN
  dx := Abs( x2 - x1 );
  sx := Sgn( x2 - x1 );
  dy := Abs( y2 - y1 );
  sy := Sgn( y2 - y1 );
  steep := ( dy > dx );
  IF steep THEN
    BEGIN
      SwapInt( x1, y1 );
      SwapInt( dx, dy );
      SwapInt( sx, sy )
    END;
  e := 2 * dy - dx;
  FOR j := 1 TO dx DO
    BEGIN
      IF steep THEN PutPixel10Eh( y1, x1, color )
               ELSE PutPixel10Eh( x1, y1, color );
      WHILE e >= 0 DO
	BEGIN
	  Inc( y1, sy );
	  Dec( e, 2 * dx )
	END;
      Inc( x1, sx );
      Inc( e, 2 * dy )
    END;
  PutPixel10Eh( x2, y2, color )
END;

{fertig fr 64K Farben gendert}
procedure PutPixelWindow10Eh(x,y : longint; c : word);
begin
  if (x>= WinX1) and (x<=WinX2) and (y>= WinY1) and (y<=WinY2) then
    putpixel10Eh(x,y,c);
end;

{fertig fr 64K Farben gendert}
function GetPixelWindow10Eh(x,y : longint):word;
begin
  if (x>= WinX1) and (x<=WinX2) and (y>= WinY1) and (y<=WinY2) then
    GetPixelWindow10Eh := GetPixel10Eh(x,y);
end;

{fertig fr 64k Farben gendert}
procedure RectangleWindow10Eh(x1,y1,x2,y2,x3,y3,x4,y4:longint; c : word);
var rx1,ry1,rx2,ry2,rx3,ry3,rx4,ry4:longint;
    page:word;
begin
  if ((x1 > Winx2) and (x2 > Winx2) and (x3 > Winx2) and (x4 > Winx2)) or
     ((x1 < Winx1) and (x2 < Winx1) and (x3 < Winx1) and (x4 < Winx1)) or
     ((y1 > Winy2) and (y2 > Winy2) and (y3 > Winy2) and (y4 > Winy2)) or
     ((y1 < Winy1) and (y2 < Winy1) and (y3 < Winy1) and (y4 < Winy1)) then
     begin
       exit;
     end;
  for page:=0 to 1 do begin
    rx1:=CalcPageX(integer(x1),page);
    ry1:=CalcPageY(integer(y1),page);
    rx2:=CalcPageX(integer(x2),page);
    ry2:=CalcPageY(integer(y2),page);
    rx3:=CalcPageX(integer(x3),page);
    ry3:=CalcPageY(integer(y3),page);
    rx4:=CalcPageX(integer(x4),page);
    ry4:=CalcPageY(integer(y4),page);
    ActVPage:=ActVPage10Eh[page];
    SetWindow(Windows10Eh[page,1],Windows10Eh[page,3],Windows10Eh[page,2],Windows10Eh[page,4]);
    RectangleWindow(rx1,ry1,rx2,ry2,rx3,ry3,rx4,ry4,c);
  end;
end;

{fertig fr 64K Farben gendert}
procedure TriangleWindow10Eh(x1,y1,x2,y2,x3,y3:longint; c : word);
begin
  RectangleWindow10Eh(x1,y1,x2,y2,x3,y3,x3,y3,c);
end;

{fertig fr 64K Farben gendert}
PROCEDURE LineWindow10Eh( x1, y1, x2, y2 : longint; color : word );
VAR j, steps, sx, sy, dx, dy, e : Integer;
    steep : Boolean;
BEGIN
  dx := Abs( x2 - x1 );
  sx := Sgn( x2 - x1 );
  dy := Abs( y2 - y1 );
  sy := Sgn( y2 - y1 );
  steep := ( dy > dx );
  IF steep THEN
    BEGIN
      SwapInt( x1, y1 );
      SwapInt( dx, dy );
      SwapInt( sx, sy )
    END;
  e := 2 * dy - dx;
  FOR j := 1 TO dx DO
    BEGIN
      IF steep THEN PutPixelWindow10Eh( y1, x1, color )
               ELSE PutPixelWindow10Eh( x1, y1, color );
      WHILE e >= 0 DO
	BEGIN
	  Inc( y1, sy );
	  Dec( e, 2 * dx )
	END;
      Inc( x1, sx );
      Inc( e, 2 * dy )
    END;
  PutPixelWindow10Eh( x2, y2, color )
END;


{fertig fr 64K Farben gendert}
procedure PutSpriteWindow10Eh(x,y:integer; p: TSprite );
var b:byte;
    page:word;
begin
  page := 0;
  repeat
    ActVPage:=ActVPage10Eh[page];
    SetWindow(Windows10Eh[page,1],Windows10Eh[page,3],Windows10Eh[page,2],Windows10Eh[page,4]);
    PutSpriteWindow(CalcPageX(x,page),CalcPageY(y,page),p);
    inc(page);
  until page > 1;
end;

{fertig fr 64K Farben gendert}
procedure PutSpriteWindowTrans10Eh(x,y:integer; trans:word; p: TSprite );
var b:byte;
    page:word;
begin
  page := 0;
  repeat
    ActVPage:=ActVPage10Eh[page];
    SetWindow(Windows10Eh[page,1],Windows10Eh[page,3],Windows10Eh[page,2],Windows10Eh[page,4]);
    PutSpriteWindowTrans(CalcPageX(x,page),CalcPageY(y,page),trans,p);
    inc(page);
  until page > 1;
end;

procedure PutSpriteWindowShadow10Eh(x,y:integer; SubR, SubG, SubB : byte; p: TSprite );
var page:word;
begin
  page := 0;
  repeat
    ActVPage:=ActVPage10Eh[page];
    SetWindow(Windows10Eh[page,1],Windows10Eh[page,3],Windows10Eh[page,2],Windows10Eh[page,4]);
    PutSpriteWindowShadow(CalcPageX(x,page),CalcPageY(y,page),subR,subG,subB,p);
    inc(page);
  until page > 1;
end;

procedure PutSpriteWindowLight10Eh(x,y:integer; AddR, AddG, AddB : byte; p: TSprite );
var page:word;
begin
  page := 0;
  repeat
    ActVPage:=ActVPage10Eh[page];
    SetWindow(Windows10Eh[page,1],Windows10Eh[page,3],Windows10Eh[page,2],Windows10Eh[page,4]);
    PutSpriteWindowLight(CalcPageX(x,page),CalcPageY(y,page),addR,addG,addB,p);
    inc(page);
  until page > 1;
end;

procedure PutSpriteWindowMix10Eh(x,y:integer; p: TSprite );
var page:word;
begin
  page := 0;
  repeat
    ActVPage:=ActVPage10Eh[page];
    SetWindow(Windows10Eh[page,1],Windows10Eh[page,3],Windows10Eh[page,2],Windows10Eh[page,4]);
    PutSpriteWindowMix(CalcPageX(x,page),CalcPageY(y,page),p);
    inc(page);
  until page > 1;
end;

procedure PutSpriteWindowAdd10EH(x,y : integer; p : TSprite);
var page:word;
begin
  page := 0;
  repeat
    ActVPage:=ActVPage10Eh[page];
    SetWindow(Windows10Eh[page,1],Windows10Eh[page,3],Windows10Eh[page,2],Windows10Eh[page,4]);
    PutSpriteWindowAdd(CalcPageX(x,page),CalcPageY(y,page),p);
    inc(page);
  until page > 1;
end;

{fertig fr 64K Farben gendert}
procedure GetSprite10Eh(x,y:integer; p: TSprite );
var b:byte;
    rx1,ry1:longint;
    bank:word;
begin
  for bank:=0 to 1 do begin
    rx1:=calcpagex(x,bank);
    ry1:=calcpagey(y,bank);
    ActVPage:=ActVPage10Eh{.p}[bank];
    SetWindow(Windows10Eh[bank,1],Windows10Eh[bank,3],Windows10Eh[bank,2],Windows10Eh[bank,4]);
    GetSpriteWindow(rx1,ry1,p);
  end;
end;

{Hier sind die SCALING Routinen}

{procedure, die fr _VIDEO13h.pas angepat wurde}
procedure PutSpriteScaled10Eh(x,y,dx,dy:integer; p: TSprite );
var b:byte;
    rx,ry : integer;
    page:word;
begin
  page := 0;
  repeat
    rx:=CalcPageX(x,page);
    ry:=CalcPageY(y,page);
    ActVPage:= ActVPage10Eh[page];
    SetWindow(Windows10Eh[page,1],Windows10Eh[page,3],Windows10Eh[page,2],Windows10Eh[page,4]);
    _scale1(rx,ry,dx,dy,p.b,p.t,{Ptr(seg(p.mem^),ofs(p.mem^))}p.mem);
    inc(page);
  until page > 1;
end;

procedure PutSpritePerCent10Eh(x,y:integer; factor:real; p : tsprite);
var b:byte;
    rx,ry : integer;
    page:word;
begin
  page := 0;
  repeat
    rx:=CalcPageX(x,page);
    ry:=CalcPageY(y,page);
    ActVPage:= ActVPage10Eh[page];
    SetWindow(Windows10Eh[page,1],Windows10Eh[page,3],Windows10Eh[page,2],Windows10Eh[page,4]);
    _scale1(rx,ry,
          trunc(p.b*0.01*factor),
          trunc(p.t*0.01*factor),p.b,p.t,
          p.mem);
    inc(page);
  until page > 1;
end;

procedure PutSpriteScaledTrans10Eh(x,y,dx,dy:integer; Tcol:word; p: Tsprite );
var b:byte;
    rx,ry : integer;
    page:word;
begin
  TransparentColor := TCol;
  page := 0;
  repeat
    rx:=CalcPageX(x,page);
    ry:=CalcPageY(y,page);
    ActVPage:= ActVPage10Eh[page];
    SetWindow(Windows10Eh[page,1],Windows10Eh[page,3],Windows10Eh[page,2],Windows10Eh[page,4]);
    _scale1trans(rx,ry,dx,dy,p.b,p.t,p.mem{Ptr(seg(p.mem^),ofs(p.mem^))});
    inc(page);
  until page > 1;
end;

procedure PutSpritePerCentTrans10Eh(x,y:integer; factor:real; Tcol:word; p : TSprite );
var b:byte;
    rx,ry : integer;
    page:word;
begin
  TransparentColor := TCol;
  page := 0;
  repeat
    rx:=CalcPageX(x,page);
    ry:=CalcPageY(y,page);
    ActVPage:= ActVPage10Eh[page];
    SetWindow(Windows10Eh[page,1],Windows10Eh[page,3],Windows10Eh[page,2],Windows10Eh[page,4]);
    _scale1trans(rx,ry,
          trunc(p.b*0.01*factor),
          trunc(p.t*0.01*factor),p.b,p.t,
          p.mem);
    inc(page);
  until page > 1;
end;

begin
end.