{ _VIDKRNL.PAS

  (c) vIRTUAL tECHNOLOGIES 1996
  Version 1.0

  History
    Version 1.0 Okt/96
    - general informations
      - 64K support
      - the EFF(ective)'s are removed. So everything is effective now

    - things added
      - procedure LoadTGA2Sprite(name : string; VAR p : TSprite);
      - procedure BigLoadTGA2Sprite(name : string; VAR p : TSprite; files : byte);
      - procedure SaveSprite2TGA(name : string; VAR p : TSprite);
      - procedure PutSpriteWindowLight(x,y : integer; addR,addG,addB:byte; p : TSprite);
      - procedure PutSpriteWindowMix(x,y : integer; p : TSprite);

    - things removed
      - RGB stuff
      - SaveImprocesCLB
      - PCX
      - BOX2BOX stuff
      - some line and box functions removed(cause they were bugy)

    - things changed
      - procedure LoadImprocesCLB(name : string; VAR p : TSprite; Pal:tPAL);
      - procedure BigLoadImprocesCLB(name : string; VAR p : TSprite; Pal:TPAL; Files:byte);
      - procedure PutSpriteWindowShadow(x,y : integer; SubR,SubG,SubB : byte; p : TSprite);
      - Scaling functions(yes, I've done it)

  for more information, questions and register contact us:

    Ansgar Scherp
    scherp.ansgar@informatik.uni-oldenburg.de

    Joachim Gelhaus
    j.gelhaus@flight.gun.de

    http://www.informatik.uni-oldenburg.de/~virtech/

    Mailbox : + 49 (0) 4441 / 851887
    Hotline : + 49 (0) 4441 / 851717 (english, german)

}

{$DEFINE ShareWare}

unit _VidKRNL;

interface

{$IFNDEF ShareWare}
uses _BigLoad;
{$ENDIF}
{uses crt;}

type
  { Typedefinition of a Sprite:
    word    : Sprite width
    word    : Sprite height
    pointer : Pointer to Sprite data }
  TSprite =
    record
      b,             {  width of a Sprite  }
      t   : word;    {  height of a Sprite  }
      Mem : pointer;
    end;

  { Palettetype }
  TPal =
    record r,g,b : Array[0..255] of byte; end;

  { the virtual Pagetype }
  TPage = Pointer;

type TTGAHeader= record
       LaengeID         : byte;
       ColorMapTyp      : byte;
       TARGAImageTyp    : byte;
       ColorMapOffset   : word;
       ColorMapLength   : word;
       ColorMapEntrySize: byte;
       StartX           : word;
       StartY           : word;
       Breite           : word;
       Tiefe            : word;
       Resolution       : word;
       ImageDescription : byte;
     end;

const
  {  Videomode constants  }
  Mode13h : word = $13; { MCGA-Mode 320x200x256 }
  Mode3h  : word = $3;  { TextMode }

var
  { these are equal with the visual Page SegA000:0 }
  Page0,
  VisualPage : Pointer; { ready for use with each procedure/function }

const
  wx1 : integer = 0;   { the borders of the current window }
  wx2 : integer = 319;
  wy1 : integer = 0;
  wy2 : integer = 199;

var
  TransparentColor : Word; { used by Scaling }
  ActVPage : TPage; { current active virtual page }

{ display an error message }
procedure VideoKRNLError(t:string);

{ set the ActivePage, on which you want to draw }
procedure ActivePage(page : pointer);

{ set window-edges of ActivePage }
procedure SetWindow(x1,y1,x2,y2:integer);

{ waits for a vertical retrace }
procedure Retrace;

{ copy a virtual screen to another virtual screen or to visual screen }
procedure CopyP2P(Src,Dst:pointer);
{ copy a virtual screen to visual screen }
procedure CopyP2V(src:Pointer);

{ clears a screen }
procedure ClearPage(dst:pointer);
{ clears the visual page }
procedure ClearVisualPage;

{ initialies a new virtual page }
procedure InitPage(VAR page : pointer);
{ closes a virtual page }
procedure ClosePage(page : pointer);

{ initialise a sprite; max. 64Kb huge! }
procedure InitSprite(VAR p : TSprite; b,t : word);
{ resets sprite a sprite }
procedure ResetSprite(VAR p : TSprite);
{ closes a sprite; does exactly the same as ResetSprite }
procedure CloseSprite(VAR p : TSprite);

{ load sprite from disk }
procedure LoadSprite(name : string; VAR p : TSprite);
{ save sprite to disk }
procedure SaveSprite(name : string; p : TSprite);

{ loads an ImprocesClipboard-Image }
procedure LoadImprocesCLB(name : string; VAR p : TSprite; pal : TPal);

{ load an 16 bit TGA picture}
procedure LoadTGA2Sprite(name : string; VAR p : TSprite);
{ saves an 16 bit TGA picture}
procedure SaveSprite2TGA(name : string; VAR p : TSprite);

{ load an Improces-Palette }
procedure LoadClipboardPal(name:string; VAR pal : TPal);

{ loads a palette }
procedure LoadPalette(name:string; VAR pal : TPal);
{ saves a palette }
procedure SavePalette(name:string; pal : TPal);

{ put a pixel to active screen }
procedure PutPixel(x,y : word; c : word);
{ puts a pixel on current active screen looking for window-borders }
procedure PutPixelWindow(x,y:longint; col:word);
{ puts a pixel to a Sprite}
procedure PutPixel2Sprite(p:TSprite; x,y : integer; c : word);
{ gets a pixel from active screen }
function  GetPixel(x,y : word):word;
{gets a Pixel from a Sprite}
function GetPixelfromSprite(x,y:integer; var p:TSprite):word;

{ put/get a sprite on active screen looking for window-borders;
  using byte IO }
procedure GetSpriteWindow(x,y : integer; p: TSprite);

procedure PutSpriteWindow( x,y : integer; p : TSprite );

procedure PutSpriteWindowTrans(x,y : integer;  t:word; p : TSprite);

{ draws a sprite but taking spritecolors-subtract instead ;
  good for making shadows }
procedure PutSpriteWindowShadow(x,y : integer; SubR,SubG,SubB:byte; p : TSprite);
{ same as Shadow, addX values are added to the Screen }
procedure PutSpriteWindowLight(x,y : integer; addR,addG,addB:byte; p : TSprite);
{ mixes Sprite with Background. Looks like colored glass }
procedure PutSpriteWindowMix(x,y : integer; p : TSprite);

procedure PutSpriteWindowAdd(x,y : integer; p : TSprite);

{ moves the specified spritecolor(n) up to t-colors up/down in sprite }
procedure MoveSpriteColor(p: TSprite; t:shortint; n:byte);

{ draws a filled rectanlge checking for window borders }
procedure RectangleWindow(lx1,ly1,lx2,ly2,lx3,ly3,lx4,ly4:longint;color:word);
{ draws a line checking for window borders }
procedure LineWindow(a,b,c,d:longint;col:word);
{ draws a filled trianlge checking for window borders }
procedure TriAngleWindow(X1,Y1,X2,Y2,X3,Y3:longint; Color:word);
{ draws a line }
procedure Line(X1,Y1,X2,Y2 : integer; color:word);
{ This draws a line from a,b to c,d of color col. }
Procedure Line2Sprite(p:TSprite;a,b,c,d:longint;col:word);

{ converts a sprite (size MUST be 320x200) to a page for direct read/write
  on sprite }
function  Sprite2Page( s : TSprite ) : TPage;

{guess what}
procedure PutSprite2Sprite( x,y : integer; p, destp : TSprite);
{guess again:-)}
procedure PutSprite2SpriteTrans(x,y : integer; trans : word; p, destp : Tsprite);
{fills a Sprite with 0's}
procedure ClearSprite(p:TSprite);

{$IFNDEF ShareWare}
{ ONLY for registered users }
{ same like procedure wihtout Big; these are able to use the vIRtECH
  BigFileSystem }
procedure BigLoadSprite(name : string; VAR p : TSprite; Files : byte);
procedure BigLoadImprocesCLB(name : string; VAR p : TSprite; pal : TPAL; Files : byte);
procedure BigLoadTGA2Sprite(name : string; VAR p : TSprite; Files : byte);
procedure BigLoadClipboardPal(name:string; VAR pal : TPal; Files : byte);
procedure BigLoadPalette(name:string; VAR pal : TPal; Files : byte);
{$ENDIF}

{ some little helpers }

function IntToStr(t:longint):string;
function StrToInt(t:string):longint;
function MaxI(A,B:Integer):Integer;
function MinI(A,B:Integer):Integer;
function InRangeI(value,min,max:integer):integer;
procedure SwapInt( VAR a, b );
function Sgn( a : Integer ) : Integer;


{Hier sind die SCALING Routinen}
{ scales a sprite; always using window-borders }
procedure PutSpriteScaled(x,y,dx,dy:integer; p:TSprite);
{ scales a sprite in cent; always using window-borders }
procedure PutSpritePerCent(x,y:integer; factor:real; p : TSprite);
{ scaling of transparent sprites }
procedure PutSpriteScaledTrans(x,y,dx,dy:integer; col :word; p:TSprite);
procedure PutSpritePerCentTrans(x,y:integer; factor:real; col:word; p : TSprite);

implementation

{
  No, this source is not free now!
  For register the unit or getting the source code, please contact us.
 }

VAR FreeMemory : Longint; {Wieviel Speicher hatten wir bei der Initialisierung}

const
  Copyright = '(c) vIRTUAL tECHNOLOGIES 1993-1996 - Ansgar Scherp, Joachim Gelhaus';

function IntToStr(t:longint):string;
 var r : string;
begin
  str(t,r);
  Inttostr := r;
end;

function StrToInt(t:string):longint;
 var r : longint;
     check : integer;
begin
  val(t,r,check);
  Strtoint := r;
end;

procedure SetWindow(x1,y1,x2,y2:integer);
  var h : byte;
begin
  if x1 < 0 then x1 := 0;
  if x1 > 319 then x1 := 319;
  if y1 < 0 then y1 := 0;
  if y1 > 99 then y1 := 99;
  if x2 < 0 then x2 := 0;
  if x2 > 319 then x2 := 319;
  if y2 < 0 then y2 := 0;
  if y2 > 99 then y2 := 99;
  if x1 > x2 then begin h := x2; x2 := x1; x1 := h; end;
  if y1 > y2 then begin h := y2; y2 := y1; y1 := h; end;
  wx1 := x1;
  wx2 := x2;
  wy1 := y1;
  wy2 := y2;
end;

procedure SetVideoMode(mode:word); assembler;
asm
  mov ax,mode
  int  10h
end;

procedure VideoKRNLError(t:string);
begin
  SetVideoMode( Mode3h );
  write('VideoKernel SystemError at: ');
  writeln(t);
  halt(1);
end;

procedure ActivePage(page : pointer);
begin
  ActVPage := page;
end;

procedure Retrace; assembler;
asm
  mov dx,3dah
  @vert1:
    in al,dx
    test al,8
  jz @vert1
  @vert2:
    in al,dx
    test al,8
  jnz @vert2
end;

procedure CopyP2P(Src,Dst:pointer); assembler;{WORD-VERSION // ab 386er}
ASM
  push DS
  les di, dst
  lds si, src
  mov cx, 16000
  db  66H; rep movsw
  pop ds
END;

procedure CopyP2V(src:Pointer); ASSEMBLER;{WORD-VERSION // ab 386er}
ASM
  push DS
  mov es, SegA000
  xor di, di
  lds si, src
  mov cx, 16000
  db  66H; rep movsw
  pop ds
END;

procedure ClearPage(dst:pointer); assembler;{WORD-VERSION // ab 386er}
asm
  les di,dst
  db 66H; xor ax,ax
  mov cx,16000
  db 66H; rep stosw
end;

procedure ClearVisualPage;
begin
  ClearPage(VisualPage);
end;

{fertig fr 64K Farben gendert}
procedure PutPixel(x,y : word; c : word); assembler;
asm
  mov ax,y
  mov bx,640
  mul bx
  add ax,x
  add ax,x

  mov cx,c
  les di, ActVPage
  add di,ax

  mov [es:di],cl
  mov [es:di+1],ch
end;

{fertig fr 64K Farben gendert}
function GetPixel(x,y : word):word;
  var c : word;
begin
  asm
    mov ax,y
    mov bx,640
    mul bx
    add ax,x
    add ax,x

    les di,ActVPage
    add di,ax
    mov cl,[es:di]
    mov ch,[es:di+1]
    mov c,cx
  end;
  GetPixel := c;
end;

{fertig fr 64K Farben gendert}
procedure LineSlow(x1,y1,x2,y2:integer; farbe:word);
var y   : integer;   {fr das Funktionsergebnis}
    m,b : real;     {Steigung und Achsenabschnitt}
    h : integer;
begin
 if x1 > x2 then begin h := x1; x1 := x2; x2 := h; end;
 if y1 > y2 then begin h := y1; y1 := y2; y2 := h; end;
 if x2<>x1 then begin {kann man Geradengleichung anwenden?}
   m:=(y2-y1)/(x2-x1);  {ja, berechne M}
   b:=y1-(m*x1);        {und B}
   for x1:=x1 to x2 do begin {Berechne in einer Schleife zu jedem}
      y:=trunc(m*x1+b); {X ein Y und}
      if (y >= 0) and (y<=199) and (x1>=0) and (x1<=319) then
	PutPixel(x1,y,farbe); {zeichne den Punkt Schleife schlieen}
    end;
  end
 else      {Es ist eine Senkrechte}
  begin
    for y1:=y1 to y2 do {setze in einer Schleife}
      PutPixel(x1,y1,farbe); {die Senkrechte}
  end;
end;

{fertig fr 64K Farben gendert}{Funktioniert nicht ganz richtig! }
procedure Line(X1,Y1,X2,Y2 : integer; color:word);
begin
  LineSlow(x1,y1,x2,y2,color);
end;

procedure InitPage(VAR page : pointer);
begin
  if page <> NIL then VideoKRNLError('Trying to open an already existing page!');
  GetMem(page,64000);
  ActVPage := page;
  ClearPage(ActVPage);
end;

procedure ClosePage(page : pointer);
begin
  if page = NIL then VideoKRNLError('Trying to close an already closed page!');
  FreeMem(page,64000);
end;

procedure InitSprite(VAR p : TSprite; b,t : word);
begin
  if (b < 1) or (t < 1) then
      VideoKRNLError('InitSprite: Breite/Hhe zu klein!');
  if (p.mem <> NIL) and (b>0) then VideoKRNLError('Trying to open an already existing sprite!');
  GetMem(p.mem,b*t*2);
  p.b := b;
  p.t := t;
  {Leere den neuen Speicher}
  FillChar(p.mem^,b*t*2,0);
end;

procedure ResetSprite(VAR p : TSprite);
begin
  if (p.b > 0) and (p.t > 0) then FreeMem(p.mem, p.b * p.t * 2);
  p.mem := nil;
  p.b := 0;
  p.t := 0;
end;

procedure CloseSprite(VAR p : TSprite);
begin
{  if p.mem = NIL then VideoKRNLError('Trying to close an already closed sprite!');}
  if (p.b*p.t > 0) and (p.mem<>NIL) then FreeMem(p.mem,p.b*p.t*2);
  p.mem := nil;
  p.b := 0;
  p.t := 0;
end;

{fertig fr 64K Farben gendert}
procedure LoadSprite(name : string; VAR p : TSprite);
  var f : file;
begin
  if p.mem <> NIL then
    VideoKRNLError('Trying to load a Sprite in an exiting one!');
  {$I-}
  assign(f,name);
  reset(f,1);
  {$I+}
  if IOResult <> 0 then VideoKRNLError('Error occurred when trying to load "'+name+'".');
  {}
  blockread(f,p.b,2);
  blockread(f,p.t,2);
  GetMem(p.mem,p.b*p.t*2);
  blockread(f,p.mem^,p.b*p.t*2);
  close(f);
end;

{$IFNDEF ShareWare}
{fertig fr 64K Farben gendert}
procedure BigLoadSprite(name : string; VAR p : TSprite; FileS:byte);
  var nope : word;
begin
  if (p.mem <> NIL) and (p.b>0) then
    VideoKRNLError('Trying to load a Sprite in an exiting one!');
  {$I-}
  bigassign(FileS,name);
  bigreset(FileS,1);
  {$I+}
  if IOResult <> 0 then VideoKRNLError('Error occurred when trying to load "'+name+'".');
  bigblockread(FileS,p.b,2,nope);
  bigblockread(FileS,p.t,2,nope);
  GetMem(p.mem,p.b*p.t*2);
  bigblockread(FileS,p.mem^,p.b*p.t*2,nope);
  bigclose(FileS);
end;
{$ENDIF}

{fertig fr 64K Farben gendert}
procedure SaveSprite(name : string; p : TSprite);
  var f : file;
begin
  {$I-}
  assign(f,name);
  rewrite(f,1);
  {$I+}
  {}
  blockwrite(f,p.b,Sizeof(p.b));
  blockwrite(f,p.t,Sizeof(p.t));
{  blockwrite(f,p.memSeg,SizeOf(p.memSeg));
  blockwrite(f,p.memOfs,SizeOf(p.memOfs));}
  blockwrite(f,p.mem^,p.b*p.t*2);
  {}
  close(f);
  if IOResult <> 0 then VideoKRNLError('Error occurred when trying to save "'+name+'".');
end;

{fertig fr 64K Farben gendert}
procedure LoadImprocesCLB(name : string; VAR p : TSprite;pal:tPAL);
 { DIMS:0 0 319 199 }
  const scan : string[5] = 'DIMS:';
  var f : file;
      t : string[5];
      b : byte;
      h : word;
      x1,x2,y1,y2 : word;
      buffer:pointer;
      bufseg, bufofs:word;
      pseg, pofs:word;
      x,y,c2:word;
      c1:byte;
      r1,g1,b1:byte;

  procedure LoadNumber(VAR z : word);
    var Check : Integer;
  begin
    t := '';
    repeat
      blockread(f,b,1);
      if IOResult <> 0 then VideoKRNLError('"'+name+'" is not an IMPROCES-File.');
      if chr(b) <> ' ' then t := t + chr(b);
    until (chr(b) = ' ') or (Eof(f));
    Val(t,z,check);
    if Check <> 0 then VideoKRNLError('Error in loading IMPROCES-File.');
  end;

begin
  if (p.mem <> NIL) and (p.b>0) then
    VideoKRNLError('Trying to load a Sprite in an exiting one!');
  {$I-}
  assign(f,name);
  reset(f,1);
  if IOResult <> 0 then VideoKRNLError('Error occurred when trying to load "'+name+'".');
  {}
  if filesize(f)-50 < 1 then seek(f,0) else seek(f,filesize(f)-50);
  t := '01234';
  repeat
    t[1] := t[2]; t[2] := t[3]; t[3] := t[4]; t[4] := t[5];
    blockread(f,t[5],1);
    if IOResult <> 0 then VideoKRNLError('"'+name+'" is not an IMPROCES-File.');
  until t = 'DIMS:';
  {$I+}
  LoadNumber(x1);
  LoadNumber(y1);
  LoadNumber(x2);
  LoadNumber(y2);
  p.b := x2 - x1 + 1;
  p.t := y2 - y1 + 1;
  seek(f,0);

  GetMem(p.mem,p.b*p.t*2);
  getMem(buffer,p.b*p.t);
  blockread(f,buffer^,p.b*p.t);
  clearSprite(p);
  bufseg:=seg(buffer^); bufofs:=ofs(buffer^);
  pseg:=seg(p.mem^); pofs:=ofs(p.mem^);
  for x:=0 to p.b*p.t-1  do begin
     c1:=mem[bufseg:bufofs];
     r1:=pal.r[c1]; g1:=pal.g[c1]; b1:=pal.b[c1];
     r1:=r1 shr 1; g1:=g1 shr 1; b1:=b1 shr 1;
     c2:=(r1 shl 11) + (g1 shl  6) + (b1);
     if c1=0 then c2:=0 else if c2=0 then c2:=1;
     memw[pseg:pofs]:=c2;
     inc(bufofs);
     inc(pofs,2);
   end;
  freemem(buffer,p.b*p.t);
  close(f);
end;

{$IFNDEF ShareWare}
{fertig fr 64K Farben gendert}
procedure BigLoadImprocesCLB(name : string; VAR p : TSprite; pal:tPAL; Files:byte);
 { DIMS:0 0 319 199 }
  const scan : string[5] = 'DIMS:';
  var t : string[5];
      b : byte;
      h : word;
      x1,x2,y1,y2 : word;
      buffer:pointer;
      bufseg, bufofs:word;
      pseg, pofs:word;
      x,y,c2:word;
      c1:byte;
      r1,g1,b1:byte;

      nope:word;

  procedure LoadNumber(VAR z : word);
    var Check : Integer;
  begin
    t := '';
    repeat
      bigblockread(files,b,1,nope);
      if IOResult <> 0 then VideoKRNLError('"'+name+'" is not an IMPROCES-File.');
      if chr(b) <> ' ' then t := t + chr(b);
    until (chr(b) = ' ') or (BigEof(files));
    Val(t,z,check);
    if Check <> 0 then VideoKRNLError('Error in loading IMPROCES-File.');
  end;

begin
  if (p.mem <> NIL) and (p.b>0) then
    VideoKRNLError('Trying to load a Sprite in an exiting one!');
  {$I-}
  bigassign(files,name);
  bigreset(files,1);
  if IOResult <> 0 then VideoKRNLError('Error occurred when trying to load "'+name+'".');
  {}
  if bigfilesize(FileS)-50 < 1 then bigseek(FileS,0) else bigseek(FileS,bigfilesize(FileS)-50);
  t := '01234';
  repeat
    t[1] := t[2]; t[2] := t[3]; t[3] := t[4]; t[4] := t[5];
    bigblockread(files,t[5],1,nope);
    if IOResult <> 0 then VideoKRNLError('"'+name+'" is not an IMPROCES-File.');
  until t = 'DIMS:';
  {$I+}
  LoadNumber(x1);
  LoadNumber(y1);
  LoadNumber(x2);
  LoadNumber(y2);
  p.b := x2 - x1 + 1;
  p.t := y2 - y1 + 1;
  bigseek(FileS,0);

  GetMem(p.mem,p.b*p.t*2);
  getMem(buffer,p.b*p.t);
  bigblockread(FileS,buffer^,p.b*p.t,nope);
  clearSprite(p);
  bufseg:=seg(buffer^); bufofs:=ofs(buffer^);
  pseg:=seg(p.mem^); pofs:=ofs(p.mem^);
  for x:=0 to p.b*p.t-1  do begin
     c1:=mem[bufseg:bufofs];
     r1:=pal.r[c1]; g1:=pal.g[c1]; b1:=pal.b[c1];
     r1:=r1 shr 1; g1:=g1 shr 1; b1:=b1 shr 1;
     c2:=(r1 shl 11) + (g1 shl  6) + (b1);
     if c1=0 then c2:=0 else if c2=0 then c2:=1;
     memw[pseg:pofs]:=c2;
     inc(bufofs);
     inc(pofs,2);
   end;
  freemem(buffer,p.b*p.t);
  bigclose(files);
end;
{$ENDIF}

{fertig fr 64K Farben gendert}
procedure LoadTGA2Sprite(name : string; VAR p : TSprite);
  var f : file;
      c:byte;
      n,n1 : byte;
      tgaHeader:TTGAHeader;
      buffer:pointer;
      bufferpos, bufferlength:word;
      realDataPos, realDataLength:longint;
      x,y,endx,endy:word;
      rlebuffer:array[0..1] of byte;
      pbx2:word;
      datastart:word;
      w:word;
      r,g,b:byte;

  function getNextByte:byte;
  var r,g:word;
      b:byte;
  begin
    {Neue Daten von Platte einlesen}
    if bufferpos=bufferlength then begin
      if realDatapos+64000<realDataLength then r:=64000 else r:=realDataLength-realDataPos;
      blockread(f,buffer^,r,g);
      bufferpos:=0;
      bufferlength:=g;
    end;
    b:=mem[seg(buffer^):ofs(buffer^)+bufferpos];
    inc(bufferpos);
    inc(RealDataPos);
    getNextByte:=b;
  end;

begin
  if (p.mem <> NIL) and (p.b>0) then
    VideoKRNLError('Trying to load a Sprite in an exiting one!');
  {$I-}
  assign(f,name);
  reset(f,1);
  if (IOResult <> 0) or (fileSize(f)<sizeof(TGAHeader))then VideoKRNLError('Error occurred when trying to load "'+name+'".');
  seek(f,0);
  blockread(f,TGAHeader,sizeOf(TGAHeader));
  if (TGAHeader.Resolution <> 16) then VideoKRNLError('"'+name+'" is not an 16 bit TGA-File.');
  if (TGAHeader.TARGAImageTyp<>2) and (TGAHeader.TARGAImageTyp<>10) then
    VideoKRNLError('"'+name+'" has a color table. Please use the RGB model.');
  {$I+}
  p.b := TGAHeader.breite;
  p.t := TGAHeader.tiefe;
  pbx2:=p.b*2;
  GetMem(p.mem,pbx2*p.t);
  clearSprite(p);
  with TGAHeader do begin
    datastart:=$12+laengeID+ColorMapTyp*ColorMapLength*(ColorMapEntrySize div 8);
    seek(f,datastart);
  end;
  getmem(buffer,64000); bufferlength:=0; bufferpos:=0;
  realdatalength:=filesize(f)-datastart; realdataPos:=0;
  endx:=(pbx2)-1; endy:=p.t-1;
  if TGAHeader.TARGAImageTyp=2 then begin
    {unkomprimiert}
    for y:=endy downto 0 do begin
      for x:=0 to endx do begin
        mem[seg(p.mem^):ofs(p.mem^)+y*pbx2+x]:=getNextByte;
      end;
      for x:=0 to endx div 2 do begin
        w:=memw[seg(p.mem^):ofs(p.mem^)+y*pbx2+x*2];
        b:=w and 31; w:=w shr 5;
        g:=w and 31; w:=w shr 5;
        r:=w and 31;
        w:=(r shl 11)+(g shl 6)+b;
        memw[seg(p.mem^):ofs(p.mem^)+y*pbx2+x*2]:=w;
      end;
    end;
  end else if TGAHeader.TARGAImageTyp=10 then begin
    {RLE komprimiert. Leider noch fehlerhaft:-(}
    y:=endy; x:=0;
    repeat
      c:=getNextByte;
      n:=(c and $3F)+1;
      if (c and $80)>0 then begin
        {n mal den RLEBuffer kopieren}
        rleBuffer[0]:=getNextByte;
        rleBuffer[1]:=getNextByte;
        for n1:=1 to n do begin
          mem[seg(p.mem^):ofs(p.mem^)+y*pbx2+x]:=rleBuffer[0];
          if x<endx then inc(x) else begin
            x:=0;
            dec(y);
          end;
          mem[seg(p.mem^):ofs(p.mem^)+y*pbx2+x]:=rleBuffer[1];
          if x<endx then inc(x) else begin
            x:=0;
            dec(y);
          end;
        end;
      end else begin
        {n mal 2Bytes kopieren}
        for n1:=1 to n do begin
          mem[seg(p.mem^):ofs(p.mem^)+y*pbx2+x]:=getNextByte;
          if x<endx then inc(x) else begin
            x:=0;
            dec(y);
          end;
          mem[seg(p.mem^):ofs(p.mem^)+y*pbx2+x]:=getNextByte;
          if x<endx then inc(x) else begin
            x:=0;
            dec(y);
          end;
        end;
      end;
    until (y=0) { (x=endx)};
  end;
  close(f);
  freemem(buffer,64000);
end;

{$IFNDEF ShareWare}
{fertig fr 64K Farben gendert}
procedure BigLoadTGA2Sprite(name : string; VAR p : TSprite; Files : byte);
  var c:byte;
      n,n1 : byte;
      tgaHeader:TTGAHeader;
      buffer:pointer;
      bufferpos, bufferlength:word;
      realDataPos, realDataLength:longint;
      x,y,endx,endy:word;
      rlebuffer:array[0..1] of byte;
      pbx2:word;
      datastart:word;
      w:word;
      r,g,b:byte;
      nope:word;

  function getNextByte:byte;
  var r,g:word;
      b:byte;
  begin
    {Neue Daten von Platte einlesen}
    if bufferpos=bufferlength then begin
      if realDatapos+64000<realDataLength then r:=64000 else r:=realDataLength-realDataPos;
      bigblockread(files,buffer^,r,g);
      bufferpos:=0;
      bufferlength:=g;
    end;
    b:=mem[seg(buffer^):ofs(buffer^)+bufferpos];
    inc(bufferpos);
    inc(RealDataPos);
    getNextByte:=b;
  end;

begin
  if (p.mem <> NIL) and (p.b>0)then
    VideoKRNLError('Trying to load a Sprite in an exiting one!');
  {$I-}
  bigassign(files,name);
  bigreset(files,1);
  if (IOResult <> 0) or (bigfileSize(files)<sizeof(TGAHeader)) then
    VideoKRNLError('Error occurred when trying to load "'+name+'".');
  bigseek(files,0);
  bigblockread(files,TGAHeader,sizeOf(TGAHeader),nope);
  if (TGAHeader.Resolution <> 16) then VideoKRNLError('"'+name+'" is not an 16 bit TGA-File.');
  if (TGAHeader.TARGAImageTyp<>2) and (TGAHeader.TARGAImageTyp<>10) then
    VideoKRNLError('"'+name+'" has a color table. Please use the RGB model.');
  {$I+}
  p.b := TGAHeader.breite;
  p.t := TGAHeader.tiefe;
  pbx2:=p.b*2;
  GetMem(p.mem,pbx2*p.t);
  clearSprite(p);
  with TGAHeader do begin
    datastart:=$12+laengeID+ColorMapTyp*ColorMapLength*(ColorMapEntrySize div 8);
    bigseek(files,datastart);
  end;
  getmem(buffer,64000); bufferlength:=0; bufferpos:=0;
  realdatalength:=bigfilesize(files)-datastart; realdataPos:=0;
  endx:=(pbx2)-1; endy:=p.t-1;
  if TGAHeader.TARGAImageTyp=2 then begin
    {unkomprimiert}
    for y:=endy downto 0 do begin
      for x:=0 to endx do begin
        mem[seg(p.mem^):ofs(p.mem^)+y*pbx2+x]:=getNextByte;
      end;
      for x:=0 to endx div 2 do begin
        w:=memw[seg(p.mem^):ofs(p.mem^)+y*pbx2+x*2];
        b:=w and 31; w:=w shr 5;
        g:=w and 31; w:=w shr 5;
        r:=w and 31;
        w:=(r shl 11)+(g shl 6)+b;
        memw[seg(p.mem^):ofs(p.mem^)+y*pbx2+x*2]:=w;
      end;
    end;
  end else if TGAHeader.TARGAImageTyp=10 then begin
    {RLE komprimiert. Leider noch fehlerhaft:-(}
    y:=endy; x:=0;
    repeat
      c:=getNextByte;
      n:=(c and $3F)+1;
      if (c and $80)>0 then begin
        {n mal den RLEBuffer kopieren}
        rleBuffer[0]:=getNextByte;
        rleBuffer[1]:=getNextByte;
        for n1:=1 to n do begin
          mem[seg(p.mem^):ofs(p.mem^)+y*pbx2+x]:=rleBuffer[0];
          if x<endx then inc(x) else begin
            x:=0;
            dec(y);
          end;
          mem[seg(p.mem^):ofs(p.mem^)+y*pbx2+x]:=rleBuffer[1];
          if x<endx then inc(x) else begin
            x:=0;
            dec(y);
          end;
        end;
      end else begin
        {n mal 2Bytes kopieren}
        for n1:=1 to n do begin
          mem[seg(p.mem^):ofs(p.mem^)+y*pbx2+x]:=getNextByte;
          if x<endx then inc(x) else begin
            x:=0;
            dec(y);
          end;
          mem[seg(p.mem^):ofs(p.mem^)+y*pbx2+x]:=getNextByte;
          if x<endx then inc(x) else begin
            x:=0;
            dec(y);
          end;
        end;
      end;
    until (y=0) { (x=endx)};
  end;
  bigclose(files);
  freemem(buffer,64000);
end;
{$EndIF}

procedure SaveSprite2TGA(name : string; VAR p : TSprite);
  var f : file;
      tgaHeader:TTGAHeader;
      buffer:pointer;
      endy:word;
      x,y:integer;
      pbx2:word;
      CreateLine:string[80];
      c:word;
      r,g,b,w:word;
begin
  if p.mem = NIL then
    VideoKRNLError('Trying to save a no existing Sprite!');
  {$I-}
  assign(f,name);
  rewrite(f,1);
  if (IOResult <> 0) then VideoKRNLError('Error occurred when trying to save "'+name+'".');
  with TGAHeader do begin
    LaengeID         :=0;
    ColorMapTyp      :=0;
    TARGAImageTyp    :=2;
    ColorMapOffset   :=0;
    ColorMapLength   :=0;
    ColorMapEntrySize:=0;
    StartX           :=0;
    StartY           :=0;
    Breite           :=p.b;
    Tiefe            :=p.t;
    Resolution       :=16;
    ImageDescription :=00;
  end;
  blockwrite(f,TGAHeader,sizeOf(TGAHeader));
  seek(f, filepos(f)-1);
  {$I+}
  pbx2:=p.b*2;
  endy:=p.t-1;
   {unkomprimiert}
  for y:=endy downto  0 do begin
    buffer:= ptr( seg(p.mem^), ofs(p.mem^)+y*pbx2);
    getmem(buffer,pbx2);
    for x:=0 to pbx2-1 do
      mem[seg(buffer^):ofs(buffer^)+x]:=mem[seg(p.mem^):ofs(p.mem^)+y*pbx2+x];
    for x:=0 to p.b-1 do begin
      w:=memw[seg(buffer^):ofs(buffer^)+x*2];
      b:=w and 31; w:=w shr 6;
      g:=w and 31; w:=w shr 5;
      r:=w and 31;
      w:=(r shl 10) + (g shl 5) + b;
      memw[seg(buffer^):ofs(buffer^)+x*2]:=w;
    end;
    blockwrite(f,buffer^,pbx2);
    freemem(buffer,pbx2);
  end;
  CreateLine:='created with vIRTECH gamedeveloper kit';
  blockwrite(f,createline,length(createline)+1);
  close(f);
end;

procedure LoadClipboardPal(name:string; VAR pal : TPal);
  var f : file;
      a : byte;
begin
  {$I-}
  assign(f,name);
  reset(f,1);
  blockread(f,pal.r[0],1);
  for a := 0 to 255 do begin
      blockread(f,pal.r[a],1);
      blockread(f,pal.g[a],1);
      blockread(f,pal.b[a],1);
    end;
  if IOResult <> 0 then VideoKRNLError('Error occurred when trying to load "'+name+'".');
  close(f);
  {$I+}
end;

{$IFNDEF ShareWare}
procedure BigLoadClipboardPal(name:string; VAR pal : TPal; FileS:byte);
  var a : byte;
      nope : word;
begin
  {$I-}
  bigassign(FileS,name);
  bigreset(FileS,1);
  bigblockread(FileS,pal.r[0],1,nope);
  for a := 0 to 255 do begin
      bigblockread(FileS,pal.r[a],1,nope);
      bigblockread(FileS,pal.g[a],1,nope);
      bigblockread(FileS,pal.b[a],1,nope);
    end;
  if IOResult <> 0 then VideoKRNLError('Error occurred when trying to load "'+name+'".');
  bigclose(Files);
  {$I+}
end;
{$ENDIF}

procedure LoadPalette(name:string; VAR pal : TPal);
  var f : file;
      a : byte;
begin
  {$I-}
  assign(f,name);
  reset(f,1);
  for a := 0 to 255 do begin
      blockread(f,pal.r[a],1);
      blockread(f,pal.g[a],1);
      blockread(f,pal.b[a],1);
    end;
  if IOResult <> 0 then VideoKRNLError('Error occurred when trying to load "'+name+'".');
  close(f);
  {$I+}
end;

{$IFNDEF ShareWare}
procedure BigLoadPalette(name:string; VAR pal : TPal; FileS:byte);
  var a : byte;
      nope : word;
begin
  {$I-}
  bigassign(FileS,name);
  bigreset(FileS,1);
  for a := 0 to 255 do begin
      bigblockread(FileS,pal.r[a],1,nope);
      bigblockread(FileS,pal.g[a],1,nope);
      bigblockread(FileS,pal.b[a],1,nope);
    end;
  if IOResult <> 0 then VideoKRNLError('Error occurred when trying to load "'+name+'".');
  bigclose(FileS);
  {$I+}
end;
{$ENDIF}

procedure SavePalette(name:string; pal : TPal);
  var f : file;
      a : byte;
begin
  {$I-}
  assign(f,name);
  rewrite(f,1);
  for a := 0 to 255 do begin
      blockwrite(f,pal.r[a],1);
      blockwrite(f,pal.g[a],1);
      blockwrite(f,pal.b[a],1);
    end;
  if IOResult <> 0 then VideoKRNLError('Error occurred when trying to save "'+name+'".');
  close(f);
  {$I+}
end;

{fertig fr 64K Farben gendert}
procedure GetSpriteWindow(x,y : integer; p: TSprite);
  var breite,tiefe : integer;
      ausgleich : word;
      ltrag,otrag,rtrag,utrag : integer;
      pb,newWX1,newWX2,newWY1,newWY2:word;
      newX:integer;
begin
  pb:=p.b*2;
  newWX1:=wx1*2;
  newWY1:=wy1;
  newWX2:=wx2*2+2;
  newWY2:=wy2+1;
  newX:=x*2;
  {betrge berechnen}
  if newX < newWX1 then ltrag := newWX1-newX else ltrag := 0;
  if y < newWY1 then otrag := newWY1-y else otrag := 0;
  if newX+pb > newWX2 then rtrag := newX+pb-newWX2 else rtrag := 0;
  if y+p.t > newWY2 then utrag := y+p.t-newWY2 else utrag := 0;
  {reale breite und tiefe ermitteln}
  breite := pb - ltrag - rtrag;
  tiefe := p.t - otrag - utrag;
  {wenn kleiner oder gleich Null, dann raus}
  if (breite <= 0) or (tiefe <= 0) then exit;
  {neue x und y position bestimmen}
  newX := newX + ltrag;
  y := y + otrag;
  asm
    push ds

    mov ax, 640
    sub ax, breite
    mov ausgleich, ax

    lds si,ActVPage   {source}
    mov ax,y   {y dazu}
    mov bx,640
    mul bx
    add ax,newX   {x dazu}
    add si,ax

    les di, p.mem { dest }
    mov ax, otrag
    mov bx, pb
    mul bx
    add di,ax

    mov dx,0
    @@loop:

      add di, ltrag {linker bertrag}

      mov cx, breite {Breite}

      rep movsb {{ [ES:DI] := [DS:SI] // CX = ANZAHL DER MOVES!!! }

      add si, ausgleich {grafikausgleichen 320-breite}
      add di, rtrag     {rechter bertrag}

      inc dx
      cmp dx, tiefe
      jnz @@loop

    pop ds
  end;
end;


{nur fr sprites bis 65335-Byte Gre!!!}
procedure MoveSpriteColor(p: TSprite; t:shortint; n:byte);
  var Move : byte;
begin
  asm
    mov al,t {das wollen wir dann adden..}
    mov Move,al

    mov ax,word ptr p.b
    mov cx,word ptr p.t
    mul cx  {ax hat die lnge}

    les di, p.mem {[es:di] = ptr to sprite }

    @@loop:
      mov cl,[es:di] {farbe nehmen}
      cmp cl,n
      jz @@w
	add cl,Move  {um Move erhhen}
	mov [es:di],cl {farbe schreiben}
      @@w:
      inc di {offset erhhen}

      dec ax
      cmp ax,0
    jnz @@loop
  end;
end;

procedure PutSpriteWindowShadow(x,y : integer; SubR,SubG,SubB:byte; p : TSprite);
var breite,tiefe : integer;
    ausgleich : word;
    ltrag,otrag,rtrag,utrag : integer;
    newX:integer;
    pb,pt,newWX1,newWX2,newWY1,newWY2:word;
begin
  pb:=p.b*2;
  newWX1:=wx1*2;
  newWY1:=wy1;
  newWX2:=wx2*2+2;
  newWY2:=wy2+1;
  newX:=x*2;
  {betrge berechnen}
  if newX < newWX1 then ltrag := newWX1-newX else ltrag := 0;
  if y < newWY1 then otrag := newWY1-y else otrag := 0;
  if newX+pb > newWX2 then rtrag := newX+pb-newWX2 else rtrag := 0;
  if y+p.t > newWY2 then utrag := y+p.t-newWY2 else utrag := 0;
  {reale breite und tiefe ermitteln}
  breite := pb - ltrag - rtrag;
  tiefe := p.t - otrag - utrag;
  {wenn kleiner oder gleich Null, dann raus}
  if (breite <= 0) or (tiefe <= 0) then exit;
  {neue x und y position bestimmen}
  newX := newX + ltrag;
  y := y + otrag;
  asm
    push ds

    cld {ClearDirectionFlag // di&si werden erhht bei mosv}

    mov ax, 640
    sub ax, breite
    mov ausgleich, ax

    les di, ActVPage  { DestSeg }
    mov ax, y         { DestOfs }
    mov bx, 640
    mul bx
    add ax, NewX
    add di, ax

    lds si, p.mem { SourceSeg }
    mov ax, otrag {ausgleich}
    mov bx, pb
    mul bx
    add si,ax

    mov dx,0
    mov bx,0
    @@loop:
      add si, ltrag
      mov cx, breite {Breite}
      shr cx,1
      {rep movsb {{ [ES:DI] := [DS:SI] // CX = ANZAHL DER MOVES!!! }

      @@loop2:

	mov ax, [DS:SI]
	cmp ax, 0
	jz @@weiter
          mov ax,[ES:DI]
          cmp ax,dx
          jnz @newcolor
            mov [ES:DI],bx
            jmp @@weiter
          @newcolor:
          push ax
          mov dx,ax
          mov bl,dl
          and bl,31 {B color in BL}
          shr dx,5
          mov bh,dl
          and bh,63 {G color in BH}
          shr dx,6  {R color ind DL}

          sub dl, SubR
          jnc @R1
          mov dl,0
          @R1:
          sub bh, SubG
          jnc @G1
          mov bh,0
          @G1:
          sub bl, SubB
          jnc @B1
          mov bl,0
          @B1:

          mov ax,dx
          shl ax,6
          or al,bh
          shl ax,5
          or al,bl

          pop dx
          mov bx, ax
	  mov [ES:DI], ax
	@@weiter:

        add di,2
        add si,2
      dec cx
      cmp cx,0
      jnz @@loop2


      add di, ausgleich
      add si, rtrag

    dec tiefe
    cmp tiefe,0
    jnz @@loop

    pop ds
  end;
end;

procedure PutSpriteWindowLight(x,y : integer; addR,addG,addB:byte; p : TSprite);
var breite,tiefe : integer;
    ausgleich : word;
    ltrag,otrag,rtrag,utrag : integer;
    newX:integer;
    pb,pt,newWX1,newWX2,newWY1,newWY2:word;
begin
  pb:=p.b*2;
  newWX1:=wx1*2;
  newWY1:=wy1;
  newWX2:=wx2*2+2;
  newWY2:=wy2+1;
  newX:=x*2;
  {betrge berechnen}
  if newX < newWX1 then ltrag := newWX1-newX else ltrag := 0;
  if y < newWY1 then otrag := newWY1-y else otrag := 0;
  if newX+pb > newWX2 then rtrag := newX+pb-newWX2 else rtrag := 0;
  if y+p.t > newWY2 then utrag := y+p.t-newWY2 else utrag := 0;
  {reale breite und tiefe ermitteln}
  breite := pb - ltrag - rtrag;
  tiefe := p.t - otrag - utrag;
  {wenn kleiner oder gleich Null, dann raus}
  if (breite <= 0) or (tiefe <= 0) then exit;
  {neue x und y position bestimmen}
  newX := newX + ltrag;
  y := y + otrag;
  asm
    push ds

    cld {ClearDirectionFlag // di&si werden erhht bei mosv}

    mov ax, 640
    sub ax, breite
    mov ausgleich, ax

    les di, ActVPage  { DestSeg }
    mov ax, y         { DestOfs }
    mov bx, 640
    mul bx
    add ax, NewX
    add di, ax

    lds si, p.mem { SourceSeg }
    mov ax, otrag {ausgleich}
    mov bx, pb
    mul bx
    add si,ax
    mov dx,65535
    mov bx,65535

    @@loop:
      add si, ltrag
      mov cx, breite {Breite}
      shr cx,1
      {rep movsb {{ [ES:DI] := [DS:SI] // CX = ANZAHL DER MOVES!!! }

      @@loop2:

	mov ax, [DS:SI]
	cmp ax, 0
	jz @@weiter
	  mov ax,[ES:DI]
          cmp ax,dx
          jnz @newcolor
            mov [ES:DI],bx
            jmp @@weiter
          @newcolor:
          push ax

          mov dx,ax
          mov bl,dl
          and bl,31 {B color in BL}
          shr dx,5
          mov bh,dl
          and bh,63 {G color in BH}
          shr dx,6  {R color ind DL}

          add dl, AddR
          test dl,32 {zero wenn nicht gesetzt}
          jz @R1
          mov dl,31
          @R1:
          add bh, AddG
          test bh,64
          jz @G1
          mov bh,63
          @G1:
          add bl, AddB
          test bl,32
          jz @B1
          mov bl,31
          @B1:

          mov ax,dx
          shl ax,6
          or al,bh
          shl ax,5
          or al,bl
          pop dx
          mov bx,ax
	  mov [ES:DI], ax
	@@weiter:

        add di,2
        add si,2
      dec cx
      cmp cx,0
      jnz @@loop2


      add di, ausgleich
      add si, rtrag

    dec tiefe
    cmp tiefe,0
    jnz @@loop

    pop ds
  end;
end;

procedure PutSpriteWindowMix(x,y : integer; p : TSprite);
var breite,tiefe : integer;
    ausgleich : word;
    ltrag,otrag,rtrag,utrag : integer;
    newX:integer;
    pb,pt,newWX1,newWX2,newWY1,newWY2:word;
    r,g,b:byte;
begin
  pb:=p.b*2;
  newWX1:=wx1*2;
  newWY1:=wy1;
  newWX2:=wx2*2+2;
  newWY2:=wy2+1;
  newX:=x*2;
  {betrge berechnen}
  if newX < newWX1 then ltrag := newWX1-newX else ltrag := 0;
  if y < newWY1 then otrag := newWY1-y else otrag := 0;
  if newX+pb > newWX2 then rtrag := newX+pb-newWX2 else rtrag := 0;
  if y+p.t > newWY2 then utrag := y+p.t-newWY2 else utrag := 0;
  {reale breite und tiefe ermitteln}
  breite := pb - ltrag - rtrag;
  tiefe := p.t - otrag - utrag;
  {wenn kleiner oder gleich Null, dann raus}
  if (breite <= 0) or (tiefe <= 0) then exit;
  {neue x und y position bestimmen}
  newX := newX + ltrag;
  y := y + otrag;
  asm
    push ds

    cld {ClearDirectionFlag // di&si werden erhht bei mosv}

    mov ax, 640
    sub ax, breite
    mov ausgleich, ax

    les di, ActVPage  { DestSeg }
    mov ax, y         { DestOfs }
    mov bx, 640
    mul bx
    add ax, NewX
    add di, ax

    lds si, p.mem { SourceSeg }
    mov ax, otrag {ausgleich}
    mov bx, pb
    mul bx
    add si,ax

    mov cx,breite
    shr cx,1
    mov breite,cx

    @@loop:
      add si, ltrag
      mov cx, breite {Breite}
{      shr cx,1
      {rep movsb {{ [ES:DI] := [DS:SI] // CX = ANZAHL DER MOVES!!! }

      @@loop2:
	mov ax, [DS:SI]
	cmp ax, 0
	jz @@weiter
          xor dh,dh
          mov bx, [ES:DI]
          push ax
          push bx
          and al,31
          and bl,31
          add al,bl
          shr al,1
          mov dl,al

          pop bx
          pop ax
          push ax
          push bx
          and ax,(63 shl 5)
          and bx,(63 shl 5)
          add ax,bx
          shr ax,1
          and ax,(63 shl 5)
          or dx,ax

          pop bx
          pop ax
          and ah,(31 shl 03)
          and bh,(31 shl 03)
          shr ah,1
          shr bh,1
          add ah,bh
          and ah,(31 shl 3)
          or dh,ah

          mov [ES:DI],dx

(*          push ax
	  mov ax,[ES:DI]
          mov dx,ax
          mov bl,dl
          and bl,31 {B color in BL}
          shr dx,5
          mov bh,dl
          and bh,63 {G color in BH}
          shr dx,6  {R color ind DL}
          mov r,dl
          mov g,bh
          mov b,bl
          pop ax

          mov dx,ax
          mov bl,dl
          and bl,31 {B color in BL}
          shr dx,5
          mov bh,dl
          and bh,63 {G color in BH}
          shr dx,6  {R color ind DL}

          add dl,r
          shr dl,1
          add bh,g
          shr bh,1
          add bl,b
          shr bl,1

          mov ax,dx
          shl ax,6
          or al,bh
          shl ax,5
          or al,bl

	  mov [ES:DI], ax*)
	@@weiter:

        add di,2
        add si,2
      dec cx
      cmp cx,0
      jnz @@loop2


      add di, ausgleich
      add si, rtrag

    dec tiefe
    cmp tiefe,0
    jnz @@loop

    pop ds
  end;
end;

procedure PutSpriteWindowAdd(x,y : integer; p : TSprite);
var breite,tiefe : integer;
    ausgleich : word;
    ltrag,otrag,rtrag,utrag : integer;
    newX:integer;
    pb,pt,newWX1,newWX2,newWY1,newWY2:word;
    r,g,b:byte;
begin
  pb:=p.b*2;
  newWX1:=wx1*2;
  newWY1:=wy1;
  newWX2:=wx2*2+2;
  newWY2:=wy2+1;
  newX:=x*2;
  {betrge berechnen}
  if newX < newWX1 then ltrag := newWX1-newX else ltrag := 0;
  if y < newWY1 then otrag := newWY1-y else otrag := 0;
  if newX+pb > newWX2 then rtrag := newX+pb-newWX2 else rtrag := 0;
  if y+p.t > newWY2 then utrag := y+p.t-newWY2 else utrag := 0;
  {reale breite und tiefe ermitteln}
  breite := pb - ltrag - rtrag;
  tiefe := p.t - otrag - utrag;
  {wenn kleiner oder gleich Null, dann raus}
  if (breite <= 0) or (tiefe <= 0) then exit;
  {neue x und y position bestimmen}
  newX := newX + ltrag;
  y := y + otrag;
  asm
    push ds

    cld {ClearDirectionFlag // di&si werden erhht bei mosv}

    mov ax, 640
    sub ax, breite
    mov ausgleich, ax

    les di, ActVPage  { DestSeg }
    mov ax, y         { DestOfs }
    mov bx, 640
    mul bx
    add ax, NewX
    add di, ax

    lds si, p.mem { SourceSeg }
    mov ax, otrag {ausgleich}
    mov bx, pb
    mul bx
    add si,ax

    mov cx,breite
    shr cx,1
    mov breite,cx

    @@loop:
      add si, ltrag
      mov cx, breite

      @@loop2:
	mov ax, [DS:SI]
	cmp ax, 0
	jz @@weiter
          xor dh,dh
          mov bx, [ES:DI]
          push ax
          push bx
          and al,31
          and bl,31
          add al,bl
          test al,32 {zero wenn nicht gesetzt}
          jz @R1
          mov al,31
          @R1:
          mov dl,al

          pop bx
          pop ax
          push ax
          push bx
          and ax,(63 shl 5)
          and bx,(63 shl 5)
          add ax,bx
          test ax,(64 shl 5) {zero wenn nicht gesetzt}
          jz @G1
          mov ax,(63 shl 5)
          @G1:
          and ax,(63 shl 5)
          or dx,ax

          pop bx
          pop ax
          and ah,(31 shl 3)
          and bh,(31 shl 3)
          add ah,bh
          jnc @B1
          mov ah,(31 shl 3)
          @B1:
          and ah,(31 shl 3)
          or dh,ah

          mov [ES:DI],dx

(*          push ax
	  mov ax,[ES:DI]
          mov dx,ax
          mov bl,dl
          and bl,31 {B color in BL}
          shr dx,5
          mov bh,dl
          and bh,63 {G color in BH}
          shr dx,6  {R color ind DL}
          mov r,dl
          mov g,bh
          mov b,bl
          pop ax

          mov dx,ax
          mov bl,dl
          and bl,31 {B color in BL}
          shr dx,5
          mov bh,dl
          and bh,63 {G color in BH}
          shr dx,6  {R color ind DL}

          add dl,r
          shr dl,1
          add bh,g
          shr bh,1
          add bl,b
          shr bl,1

          mov ax,dx
          shl ax,6
          or al,bh
          shl ax,5
          or al,bl

	  mov [ES:DI], ax*)
	@@weiter:

        add di,2
        add si,2
      dec cx
      cmp cx,0
      jnz @@loop2


      add di, ausgleich
      add si, rtrag

    dec tiefe
    cmp tiefe,0
    jnz @@loop

    pop ds
  end;
end;

{**************************************************************************}

function MaxI(A,B:Integer):Integer;
begin
inline(
$58/                       {pop   ax       }
$5B/                       {pop   bx       }
$3B/$C3/                   {cmp   ax,bx    }
$7F/$01/                   {jg    +1       }
$93);                      {xchg  ax,bx    }
end;

function MinI(A,B:Integer):Integer;
begin
inline(
$58/                       {pop   ax       }
$5B/                       {pop   bx       }
$3B/$C3/                   {cmp   ax,bx    }
$7C/$01/                   {jl    +1       }
$93);                      {xchg  ax,bx    }
end;

function InRangeI(value,min,max:integer):integer;
begin
inline(
$59/                       {pop   cx  max  }
$5B/                       {pop   bx  min  }
$58/                       {pop   ax  val  }
$3B/$C3/                   {cmp   ax,bx    }
$7F/$03/                   {jg    +3       }
$93/                       {xchg  ax,bx    }
$Eb/$05/                   {jmp   +5       }
$3B/$C1/                   {cmp   ax,cx    }
$7C/$01/                   {jl    +1       }
$91);                      {xchg  ax,cx    }
{ Sign }
end;

PROCEDURE SwapInt( VAR a, b ); ASSEMBLER;
ASM
	LES     DI,[A]
	MOV     AX,ES:[DI]
	LES     DI,[B]
	XCHG    AX,ES:[DI]
	LES     DI,[A]
	MOV     ES:[DI],AX
END;


FUNCTION Sgn( a : Integer ) : Integer; ASSEMBLER;
ASM
	MOV     AX,[a]
	SAR     AX,$0E
	AND     AL,$FE
	INC     AX
END;

{**************************************************************************}

{fertig fr 64K Farben gendert}
procedure PutPixelWindow(x,y:longint; col:word);
begin
  if ( x >= wx1) and ( x <= wx2) and
     ( y >= wy1) and ( y <= wy2) then
       putpixel(x,y,col);
end;

{fertig fr 64K Farben gendert}
Procedure RectangleWindow(lx1,ly1,lx2,ly2,lx3,ly3,lx4,ly4:longint;color:word);
  { This draw a polygon with 4 points at x1,y1 , x2,y2 , x3,y3 , x4,y4
    in color col }
var
  x1,x2,x3,x4,y1,y2,y3,y4 : longint;
  x:longint;
  MinY,MaxY:longint;
  MinX,MaxX:longint;
  counter : longint;
  mul1, mul2, mul3, mul4 : longint;
  div1, div2, div3, div4 : longint;

begin
  if ((lx1 > wx2) and (lx2 > wx2) and (lx3 > wx2) and (lx4 > wx2)) or
     ((lx1 < wx1) and (lx2 < wx1) and (lx3 < wx1) and (lx4 < wx1)) or
     ((ly1 > wy2) and (ly2 > wy2) and (ly3 > wy2) and (ly4 > wy2)) or
     ((ly1 < wy1) and (ly2 < wy1) and (ly3 < wy1) and (ly4 < wy1)) then
     begin
       exit;
     end;

  x1 := integer(lx1); x2 := integer(lx2);
  x3 := integer(lx3); x4 := integer(lx4);
  y1 := integer(ly1); y2 := integer(ly2);
  y3 := integer(ly3); y4 := integer(ly4);
{  x1 := lx1;x2 := lx2;x3 := lx3;x4 := lx4;
  y1 := ly1;y2 := ly2;y3 := ly3;y4 := ly4;}

  MinY:=y1; MaxY:=y1;
  { Choose the min y MinY and max y MaxY }
  if y2<MinY then MinY:=y2;
  if y2>MaxY then MaxY:=y2;
  if y3<MinY then MinY:=y3;
  if y3>MaxY then MaxY:=y3;
  if y4<MinY then MinY:=y4;
  if y4>MaxY then MaxY:=y4;
  { Choose the min y MinY and max y MaxY }
  if MinY < wy1 then MinY:=wy1;
  if MaxY > wy2 then MaxY:=wy2;
  if MinY > wy2 then exit;
  if MaxY < wy1 then exit; { Verticle range checking }

  mul1 := x1-x4;
  mul2 := x2-x1;
  mul3 := x3-x2;
  mul4 := x4-x3;
  div1 := y1-y4;
  div2 := y2-y1;
  div3 := y3-y2;
  div4 := y4-y3;  { Constansts needed for intersection calc }

  for counter := MinY to MaxY do
    begin
      MinX:=320;
      MaxX:=-1;
      { Check that counter is between y1 and y4 }
      if (y4 >= counter) or (y1 >= counter) then
	if ( y4<=counter) or (y1 <= counter) then
	  if not(y4=y1) then
	    begin
	      x := counter-y4;
	      x := x * mul1;
	      x := x div div1;
	      inc(x,x4); { Point of intersection on x axis }
	      { Set point as start or end of horiz line }
	      if x < MinX then MinX := x;
	      if x > MaxX then MaxX := x;
	    end;
      { Check that counter is between y1 and y2 }
      if (y1 >= counter) or (y2 >= counter) then
	if (y1 <= counter) or (y2 <= counter) then
	  if not(y1=y2) then
	    begin
	      x := counter-y1;
	      x := x * mul2;
	      x := x div div2;
	      inc(x,x1); { Point of intersection on x axis }
	      if x<MinX then MinX:=x;
	      if x>MaxX then MaxX:=x;       { Set point as start or end of horiz line }
	    end;
      { Check that counter is between y2 and y3 }
      if (y2 >= counter) or (y3 >= counter) then
	if (y2 <= counter) or (y3 <= counter) then
	  if not(y2=y3) then
	    begin
	      x := counter-y2;
	      x := x * mul3;
	      x := x div div3;
	      inc(x,x2); { Point of intersection on x axis }
	      if x<MinX then MinX:=x;
	      if x>MaxX then MaxX:=x;       { Set point as start or end of horiz line }
	    end;
      { Check that counter is between y3 and y4 }
      if (y3 >= counter) or (y4 >= counter) then
	if (y3 <= counter) or (y4 <= counter) then
	  if not(y3=y4) then
	    begin
	      x := counter-y3;
	      x := x * mul4;
	      x := x div div4;
	      inc(x,x3); { Point of intersection on x axis }
	      if x<MinX then MinX:=x;
	      if x>MaxX then MaxX:=x;       { Set point as start or end of horiz line }
	    end;
      { Range checking on horizontal line }
      if MinX < wx1 then MinX:=wx1;
      if MaxX > wx2 then MaxX:=wx2;
      if MinX<=MaxX then line(MinX,counter,MaxX,counter,color);  { Draw the horizontal line }
    end;
  end;
(**)

{ -------------------------------------------------------------------------- }

{fertig fr 64K Farben gendert}
Procedure LineWindow(a,b,c,d:longint;col:word);
  { This draws a line from a,b to c,d of color col. }
Function sgn(a:real):longint;
   BEGIN
	if a>0 then sgn:=+1;
	if a<0 then sgn:=-1;
	if a=0 then sgn:=0;
   END;
var u,s,v,d1x,d1y,d2x,d2y,m,n:real;
    i:integer;
BEGIN
     u:= c - a;
     v:= d - b;
     d1x:= SGN(u);
     d1y:= SGN(v);
     d2x:= SGN(u);
     d2y:= 0;
     m:= ABS(u);
     n := ABS(v);
     IF NOT (M>N) then
     BEGIN
	  d2x := 0 ;
	  d2y := SGN(v);
	  m := ABS(v);
	  n := ABS(u);
     END;
     s := INT(m / 2);
     FOR i := 0 TO round(m) DO
     BEGIN
	  PutPixelWindow(a,b,col);
	  s := s + n;
	  IF not (s<m) THEN
	  BEGIN
	       s := s - m;
	       a:= a +round(d1x);
	       b := b + round(d1y);
	  END
	  ELSE
	  BEGIN
	       a := a + round(d2x);
	       b := b + round(d2y);
	  END;
     END;
END;

{fertig fr 64K Farben gendert}
Procedure TriAngleWindow(X1,Y1,X2,Y2,X3,Y3:longint; Color:word);
begin
 RectangleWindow(x1,y1,x2,y2,x3,y3,x3,y3,color);
end;

{fertig fr 64K Farben gendert}
function Sprite2Page( s : TSprite ) : TPage;
begin
  Sprite2Page := s.mem;
  if (s.b <> 320) or (s.t <> 100)
    then VideoKRNLError(' Spritesize is unequal to pagesize (320x100).');
end;

{fertig fr 64K Farben gendert}
procedure PutSpriteWindow( x,y : integer; p : TSprite );
var breite,tiefe : integer;
    ausgleich : word;
    LTrag,OTrag,RTrag,UTrag : integer;
    Rest : word;
    newX:integer;
    pb,pt,newWX1,newWX2,newWY1,newWY2:word;

begin
  pb:=p.b*2;
  newWX1:=wx1*2;
  newWY1:=wy1;
  newWX2:=wx2*2+2;
  newWY2:=wy2+1;
  newX:=x*2;
  {betrge berechnen}
  if newX < newWX1 then ltrag := newWX1-newX else ltrag := 0;
  if y < newWY1 then otrag := newWY1-y else otrag := 0;
  if newX+pb > newWX2 then rtrag := newX+pb-newWX2 else rtrag := 0;
  if y+p.t > newWY2 then utrag := y+p.t-newWY2 else utrag := 0;
  {reale breite und tiefe ermitteln}
  breite := pb - ltrag - rtrag;
  tiefe := p.t - otrag - utrag;
  {wenn kleiner oder gleich Null, dann raus}
  if (breite <= 0) or (tiefe <= 0) then exit;

  {ok, nun die breite/ rechter&linker-bertrag manipulieren}
  Rest := breite mod 4;
  breite := breite - Rest;
{  RTrag := RTrag + Rest;}
  {neue x und y position bestimmen}
  newX := newX + ltrag;
  y := y + otrag;

  {und nun das Mammut Assemblerteil}
  case Rest of
    0 : {*** einfach nur DWORDs schreiben!!! ***}
    asm
      {eigentlicher spritecode}
      push ds

      mov ax, 640
      sub ax, breite
      mov ausgleich, ax

      les di,ActVPage   {dest}
      mov ax,y   {y dazu}
      mov bx,640
      mul bx
      add ax, newX   {x dazu}
      add di,ax

      lds si, p.mem { Source }
      mov ax, otrag {ausgleich}
      mov bx, pb
      mul bx
      add si,ax

      mov dx,0
      @@loop:

	add si, ltrag {linker bertrag}

	mov cx,breite
	shr cx,2

	db $66; rep movsw {{ [ES:DI] := [DS:SI] // CX = ANZAHL DER MOVES!!! }

	{hier den rest anhngen}
	{HIER: Nur DWORDs!!! kein REST! }

	add di, ausgleich {grafikausgleichen 640-breite}
	add si, rtrag     {rechter bertrag}


	inc dx
	cmp dx, tiefe
	jnz @@loop

      pop ds
      @@exit:
    end;
    1 : {*** einfach nur DWORDs schreiben und hinten ein BYTE dran!!! ***}
    asm
      {eigentlicher spritecode}
      push ds

      mov ax, 640
      sub ax, breite
      mov ausgleich, ax

      dec Ausgleich { Zwei weniger fr ausgleich, da 1 Byte dran!!!}

      les di,ActVPage   {dest}
      mov ax,y   {y dazu}
      mov bx,640
      mul bx
      add ax, newX   {x dazu}
      add di,ax

      lds si, p.mem { Source }
      mov ax, otrag {ausgleich}
      mov bx, pb
      mul bx
      add si,ax

      mov dx,0
      @@loop:

	add si, ltrag {linker bertrag}

	mov cx,breite
	shr cx,2

	db $66; rep movsw {{ [ES:DI] := [DS:SI] // CX = ANZAHL DER MOVES!!! }

	{hier den rest anhngen // 1 Byte }
	movsb

	add di, ausgleich {grafikausgleichen 640-breite}
	add si, rtrag     {rechter bertrag}


	inc dx
	cmp dx, tiefe
	jnz @@loop

      pop ds
      @@exit:
    end;
    2 : {*** einfach nur DWORDs schreiben und hinten ein WORD dran!!! ***}
    asm
      {eigentlicher spritecode}
      push ds

      mov ax, 640
      sub ax, breite
      mov ausgleich, ax

      dec Ausgleich { ein weniger fr ausgleich, da 2 WORD dran!!!}
      dec Ausgleich

      les di,ActVPage   {dest}
      mov ax,y   {y dazu}
      mov bx,640
      mul bx
      add ax, newX   {x dazu}
      add di,ax

      lds si, p.mem { Source }
      mov ax, otrag {ausgleich}
      mov bx, pb
      mul bx
      add si,ax

      mov dx,0
      @@loop:

	add si, ltrag {linker bertrag}

	mov cx,breite
	shr cx,2

	db $66; rep movsw {{ [ES:DI] := [DS:SI] // CX = ANZAHL DER MOVES!!! }

	{hier den rest anhngen // 1 Byte }
	movsw

	add di, ausgleich {grafikausgleichen 640-breite}
	add si, rtrag     {rechter bertrag}


	inc dx
	cmp dx, tiefe
	jnz @@loop

      pop ds
      @@exit:
    end;
    3 : {*** einfach nur DWORDs schreiben und hinten ein WORD &
	     ein BTYE dran!!! ***}
    asm
      {eigentlicher spritecode}
      push ds

      mov ax, 640
      sub ax, breite
      mov ausgleich, ax

      dec Ausgleich { ein weniger fr ausgleich, da 1 WORD & 1 Byte dran!!!}
      dec Ausgleich
      dec Ausgleich

      les di,ActVPage   {dest}
      mov ax,y   {y dazu}
      mov bx,640
      mul bx
      add ax, newX   {x dazu}
      add di,ax

      lds si, p.mem { Source }
      mov ax, otrag {ausgleich}
      mov bx, pb
      mul bx
      add si,ax

      mov dx,0
      @@loop:

	add si, ltrag {linker bertrag}

	mov cx,breite
	shr cx,2

	db $66; rep movsw {{ [ES:DI] := [DS:SI] // CX = ANZAHL DER MOVES!!! }

	{hier den rest anhngen // 1 Word & 1 Byte }
	movsw
	movsb

	add di, ausgleich {grafikausgleichen 640-breite}
	add si, rtrag     {rechter bertrag}


	inc dx
	cmp dx, tiefe
	jnz @@loop

      pop ds
      @@exit:
    end;
  end;
end;

{fertig fr 64K Farben gendert}
procedure PutSpriteWindowTrans(x,y : integer; t:word; p : TSprite);
var
  breite,tiefe : integer;
  ausgleich : word;
  ltrag,otrag,rtrag,utrag : integer;
  Rest : Word;
  newX:integer;
  pb,pt,newWX1,newWX2,newWY1,newWY2:word;
  trans:word;
begin
  trans:=t;
  asm
    {pb:=p.b*2;}
    mov ax,p.b; shl ax,1; mov pb,ax
    {newWX1:=wx1*2;}
    mov ax,wx1; shl ax,1; mov newWX1,ax
    {newWY1:=wy1;}
    mov ax,wy1; mov newWY1,ax
    {newWX2:=wx2*2+2;}
    mov ax,wx2; shl ax,1; add ax,2; mov newWX2,ax
    {newWY2:=wy2+1;}
    mov ax,wy2; inc ax; mov newWY2,ax
    {newX:=x*2;}
    mov ax,x; shl ax,1; mov newX,ax
    {betrge berechnen}
    {if newX < newWX1 then ltrag := newWX1-newX else ltrag := 0;}
    mov LTrag, 0
    mov ax, newX
    mov bx, newWX1
    cmp ax,bx
    jge @@weiter1
      sub bx, ax
      mov LTrag, bx
    @@weiter1:
    {if y < newWY1 then otrag := newWY1-y else otrag := 0;}
    mov OTrag, 0
    mov ax, y
    mov bx, newWY1
    cmp ax,bx
    jge @@weiter2
      sub bx, ax
      mov OTrag, bx
    @@weiter2:
    {if newX+pb > newWX2 then rtrag := newX+pb-newWX2 else rtrag := 0;}
    mov RTrag, 0
    mov ax, newX
    add ax, pb
    mov bx, newWX2
    cmp ax,bx
    jle @@weiter3
      sub ax, bx
      mov RTrag, ax
    @@weiter3:
    {if y+p.t > newWY2 then utrag := y+p.t-newWY2 else utrag := 0;}
    mov UTrag, 0
    mov ax, y
    add ax, p.t
    mov bx, newWY2
    cmp ax,bx
    jle @@weiter4
      sub ax, bx
      mov UTrag, ax
    @@weiter4:

    {reale breite und tiefe ermitteln}
    {breite := pb - ltrag - rtrag;}
    mov ax, pb
    sub ax, ltrag
    sub ax, rtrag
    mov Breite, ax
    {tiefe := p.t - otrag - utrag;}
    mov ax, p.t
    sub ax, otrag
    sub ax, utrag
    mov Tiefe, ax
  end;

  {wenn kleiner oder gleich Null, dann raus}
  if (breite <= 0) or (tiefe <= 0) then exit;

  {ok, nun die breite/ rechter&linker-bertrag manipulieren}
  Rest := breite mod 2;
  breite := breite - Rest;
  {neue x und y position bestimmen}

  asm
    {newX := newX + ltrag;}
    mov ax,newX
    add ax,ltrag
    mov newX, ax
    {y := y + otrag;}
    mov ax,y
    add ax,otrag
    mov y, ax
  end;
  {*** einfach nur WORDs lesen & BYTES schreiben!!! ***}
  asm
    push ds

    mov ax, 640
    sub ax, breite
    mov ausgleich, ax

    les di,ActVPage   {dest}
    mov ax,y   {y dazu}
    mov bx,640
    mul bx
    add ax, newX   {x dazu}
    add di,ax

    lds si, p.mem { Source }
    mov ax, otrag {ausgleich}
    mov bx, pb
    mul bx
    add si,ax

    mov dx,0
    @@loop:

      add si, ltrag {linker bertrag}

      mov cx, breite {Breite}
      shr cx,1       {nur die Hlfte der Abfragen}

      @@loop2:
        mov ax, [DS:SI]{Read a word }
        cmp ax, trans

        jz @@weiter1
        mov [ES:DI],ax
        @@weiter1:

        add di,2
        add si,2

	dec cx
	cmp cx,0
      jnz @@loop2

      add di, ausgleich {grafikausgleichen 640-breite}
      add si, rtrag     {rechter bertrag}

      inc dx
      cmp dx, tiefe
    jnz @@loop
    pop ds
  end;
end;

{fertig fr 64K Farben gendert}
procedure ClearSprite(p:TSprite);
var l:word;
    ganz1,rest1,ganz2,rest2:word;
begin
  l:=p.b*p.t*2;
  rest1:=l mod 4;
  ganz1:=l div 4;
  l:=rest1;
  rest2:=l mod 2;
  ganz2:=l div 2;
  asm
    les di,p.mem
    db 66H
    xor ax,ax
    mov cx,ganz1
    db 66H
    rep stosw
    mov cx,ganz2
    rep stosw
    mov cx,rest2
    rep stosb
  end;
end;

{fertig fr 64K Farben gendert}
function GetPixelfromSprite(x,y:integer; var p:TSprite):word;
var
  t:TSprite;
  b:byte;
  pb:word;
  c:word;
begin
  x:=x*2;
  pb:=p.b*2;
  if ( x < 0 ) or ( y < 0) or
     ( x > pb-1 ) or ( y > p.t-1 ) then
       begin
	 GetPixelFromSprite := 0;
	 exit;
       end;
  t := p;
  asm
    mov ax, pb
    mov bx, y
    mul bx
    add ax, x

    les di, t.mem
    add di, ax

    mov ax, [es:di]
    mov c,  ax
  end;
  GetPixelFromSprite := c;
end;

{fertig fr 64K Farben gendert}
procedure PutPixel2Sprite(p:TSprite; x,y : integer; c : word);
var b:word;
    pb:word;
begin
  pb:=p.b*2;
  x:=x*2;
  if (x>pb-1) or (y>p.t-1) or (x<0) or (y<0) then exit;
  asm
    mov ax,y
    mov bx,pb
    mul bx
    add ax,x

    mov cx,c
    les di, p.mem
    add di,ax
    mov [es:di],cx
  end;
end;

{fertig fr 64K Farben gendert}
Procedure Line2Sprite(p:TSprite;a,b,c,d:longint;col:word);
  { This draws a line from a,b to c,d of color col. }
  Function sgn(a:real):integer;
  begin
    if a>0 then sgn:=+1;
    if a<0 then sgn:=-1;
    if a=0 then sgn:=0;
  end;
var u,s,v,d1x,d1y,d2x,d2y,m,n:real;
    i:integer;
BEGIN
  u:= c - a;
  v:= d - b;
  d1x:= SGN(u);
  d1y:= SGN(v);
  d2x:= SGN(u);
  d2y:= 0;
  m:= ABS(u);
  n := ABS(v);
  IF NOT (M>N) then
    BEGIN
      d2x := 0 ;
      d2y := SGN(v);
      m := ABS(v);
      n := ABS(u);
    END;

  s := INT(m / 2);
  FOR i := 0 TO round(m) DO
    BEGIN
      PutPixel2Sprite(p,a,b,col);
      s := s + n;
      IF not (s<m) THEN
	 BEGIN
	   s := s - m;
	   a:= a +round(d1x);
	   b := b + round(d1y);
	 END
       ELSE
	 BEGIN
	   a := a + round(d2x);
	   b := b + round(d2y);
	 END;
   END;
END;

{fertig fr 64K Farben gendert}
procedure PutSprite2Sprite( x,y : integer; p, destp : TSprite);
var destb:word;
    swx1, swx2, swy1, swy2:integer;
    breite,tiefe : integer;
    ausgleich : word;
    LTrag,OTrag,RTrag,UTrag : integer;
    Rest : word;
    newX:integer;
    pb,pt,newWX1,newWX2,newWY1,newWY2:word;
begin
  destb:=destp.b*2; {war sonst das 640}
  swx1:=0; swy1:=0; swx2:=destp.b-1; swy2:=destp.t-1;
  pb:=p.b*2;
  newWX1:=swx1*2;
  newWY1:=swy1;
  newWX2:=swx2*2+2;
  newWY2:=swy2+1;
  newX:=x*2;
  {betrge berechnen}
  if newX < newWX1 then ltrag := newWX1-newX else ltrag := 0;
  if y < newWY1 then otrag := newWY1-y else otrag := 0;
  if newX+pb > newWX2 then rtrag := newX+pb-newWX2 else rtrag := 0;
  if y+p.t > newWY2 then utrag := y+p.t-newWY2 else utrag := 0;
  {reale breite und tiefe ermitteln}
  breite := pb - ltrag - rtrag;
  tiefe := p.t - otrag - utrag;
  {wenn kleiner oder gleich Null, dann raus}
  if (breite <= 0) or (tiefe <= 0) then exit;

  {ok, nun die breite/ rechter&linker-bertrag manipulieren}
  Rest := breite mod 4;
  breite := breite - Rest;
{  RTrag := RTrag + Rest;}
  {neue x und y position bestimmen}
  newX := newX + ltrag;
  y := y + otrag;

  {und nun das Mammut Assemblerteil}
  case Rest of
    0 : {*** einfach nur DWORDs schreiben!!! ***}
    asm
      {eigentlicher spritecode}
      push ds

      mov ax, destb
      sub ax, breite
      mov ausgleich, ax

      les di,destp.mem {dest}
      mov ax,y   {y dazu}
      mov bx,destb
      mul bx
      add ax, newX   {x dazu}
      add di,ax

      lds si, p.mem { Source }
      mov ax, otrag {ausgleich}
      mov bx, pb
      mul bx
      add si,ax

      mov dx,0
      @@loop:

	add si, ltrag {linker bertrag}

	mov cx,breite
	shr cx,2

	db $66; rep movsw {{ [ES:DI] := [DS:SI] // CX = ANZAHL DER MOVES!!! }

	{hier den rest anhngen}
	{HIER: Nur DWORDs!!! kein REST! }

	add di, ausgleich {grafikausgleichen 640-breite}
	add si, rtrag     {rechter bertrag}

	inc dx
	cmp dx, tiefe
	jnz @@loop

      pop ds
      @@exit:
    end;
    1 : {*** einfach nur DWORDs schreiben und hinten ein BYTE dran!!! ***}
    asm
      {eigentlicher spritecode}
      push ds

      mov ax, destb
      sub ax, breite
      mov ausgleich, ax

      dec Ausgleich { Zwei weniger fr ausgleich, da 1 Byte dran!!!}

      les di,destp.mem   {dest}
      mov ax,y   {y dazu}
      mov bx,destb
      mul bx
      add ax, newX   {x dazu}
      add di,ax

      lds si, p.mem { Source }
      mov ax, otrag {ausgleich}
      mov bx, pb
      mul bx
      add si,ax

      mov dx,0
      @@loop:

	add si, ltrag {linker bertrag}

	mov cx,breite
	shr cx,2

	db $66; rep movsw {{ [ES:DI] := [DS:SI] // CX = ANZAHL DER MOVES!!! }

	{hier den rest anhngen // 1 Byte }
	movsb

	add di, ausgleich {grafikausgleichen 640-breite}
	add si, rtrag     {rechter bertrag}

	inc dx
	cmp dx, tiefe
	jnz @@loop

      pop ds
      @@exit:
    end;
    2 : {*** einfach nur DWORDs schreiben und hinten ein WORD dran!!! ***}
    asm
      {eigentlicher spritecode}
      push ds

      mov ax, destb
      sub ax, breite
      mov ausgleich, ax

      dec Ausgleich { ein weniger fr ausgleich, da 2 WORD dran!!!}
      dec Ausgleich

      les di,destp.mem {dest}
      mov ax,y   {y dazu}
      mov bx,destb
      mul bx
      add ax, newX   {x dazu}
      add di,ax

      lds si, p.mem { Source }
      mov ax, otrag {ausgleich}
      mov bx, pb
      mul bx
      add si,ax

      mov dx,0
      @@loop:

	add si, ltrag {linker bertrag}

	mov cx,breite
	shr cx,2

	db $66; rep movsw {{ [ES:DI] := [DS:SI] // CX = ANZAHL DER MOVES!!! }

	{hier den rest anhngen // 1 Byte }
	movsw

	add di, ausgleich {grafikausgleichen 640-breite}
	add si, rtrag     {rechter bertrag}

	inc dx
	cmp dx, tiefe
	jnz @@loop

      pop ds
      @@exit:
    end;
    3 : {*** einfach nur DWORDs schreiben und hinten ein WORD &
	     ein BTYE dran!!! ***}
    asm
      {eigentlicher spritecode}
      push ds

      mov ax, destb
      sub ax, breite
      mov ausgleich, ax

      dec Ausgleich { ein weniger fr ausgleich, da 1 WORD & 1 Byte dran!!!}
      dec Ausgleich
      dec Ausgleich

      les di,destp.mem {dest}
      mov ax,y   {y dazu}
      mov bx,destb
      mul bx
      add ax, newX   {x dazu}
      add di,ax

      lds si, p.mem { Source }
      mov ax, otrag {ausgleich}
      mov bx, pb
      mul bx
      add si,ax

      mov dx,0
      @@loop:

	add si, ltrag {linker bertrag}

	mov cx,breite
	shr cx,2

	db $66; rep movsw {{ [ES:DI] := [DS:SI] // CX = ANZAHL DER MOVES!!! }

	{hier den rest anhngen // 1 Word & 1 Byte }
	movsw
	movsb

	add di, ausgleich {grafikausgleichen 640-breite}
	add si, rtrag     {rechter bertrag}

	inc dx
	cmp dx, tiefe
	jnz @@loop

      pop ds
      @@exit:
    end;
  end;
end;

{fertig fr 64K Farben gendert}
procedure PutSprite2SpriteTrans(x,y : integer; trans : word; p, destp : TSprite);
var destb:word;
  swx1, swx2, swy1, swy2:integer;
  breite,tiefe : integer;
  ausgleich : word;
  ltrag,otrag,rtrag,utrag : integer;
  Rest : Word;
  newX:integer;
  pb,pt,newWX1,newWX2,newWY1,newWY2:word;
  t:word;
begin
  destb:=destp.b*2; {war sonst das 640}
  swx1:=0; swy1:=0; swx2:=destp.b-1; swy2:=destp.t-1;

  t:=trans;
  pb:=p.b*2;
  newWX1:=swx1*2;
  newWY1:=swy1;
  newWX2:=swx2*2+2;
  newWY2:=swy2+1;
  newX:=x*2;
  {betrge berechnen}
  if newX < newWX1 then ltrag := newWX1-newX else ltrag := 0;
  if y < newWY1 then otrag := newWY1-y else otrag := 0;
  if newX+pb > newWX2 then rtrag := newX+pb-newWX2 else rtrag := 0;
  if y+p.t > newWY2 then utrag := y+p.t-newWY2 else utrag := 0;
  {reale breite und tiefe ermitteln}
  breite := pb - ltrag - rtrag;
  tiefe := p.t - otrag - utrag;
  {wenn kleiner oder gleich Null, dann raus}
  if (breite <= 0) or (tiefe <= 0) then exit;

  {ok, nun die breite/ rechter&linker-bertrag manipulieren}
  Rest := breite mod 2;
  breite := breite - Rest;
  {neue x und y position bestimmen}
  asm
    {newX := newX + ltrag;}
    mov ax,newX
    add ax,ltrag
    mov newX, ax
    {y := y + otrag;}
    mov ax,y
    add ax,otrag
    mov y, ax
  end;
  {*** einfach nur DWORDs lesen & BYTES schreiben!!! ***}
  asm
    push ds

    mov ax, destb
    sub ax, breite
    mov ausgleich, ax

    les di,destp.mem   {dest}
    mov ax,y   {y dazu}
    mov bx,destb
    mul bx
    add ax, newX   {x dazu}
    add di,ax

    lds si, p.mem { Source }
    mov ax, otrag {ausgleich}
    mov bx, pb
    mul bx
    add si,ax

    mov dx,0
    @@loop:

      add si, ltrag {linker bertrag}

      mov cx, breite {Breite}
      shr cx,1       {nur die Hlfte der Abfragen}

      @@loop2:
        mov ax, [DS:SI]{Read a word }
        cmp ax, t
        jz @@weiter1
        mov [ES:DI],ax
        @@weiter1:
        add di,2
        add si,2

	dec cx
	cmp cx,0
      jnz @@loop2

      add di, ausgleich {grafikausgleichen 640-breite}
      add si, rtrag     {rechter bertrag}

      inc dx
      cmp dx, tiefe
    jnz @@loop
    pop ds
  end;
end;


{Hier sind die SCALING Routinen}

{Die wirkliche Scale-routine}
{$F+}
{$L _SCALE3.OBJ}
{$L _SCALE4.OBJ}

procedure _Scale1( X,Y,DW,DY,SW,SH:integer;Bitmap:pointer); external;
procedure _Scale1Trans( X,Y,DW,DY,SW,SH:integer; Bitmap:pointer ); external;
{$F-}

{procedure, die fr _VIDEO13h.pas angepat wurde}
procedure PutSpriteScaled(x,y,dx,dy:integer; p:TSprite);
begin
  _scale1(x,y,dx,dy,p.b,p.t,Ptr(seg(p.mem^),ofs(p.mem^)));
end;

procedure PutSpritePerCent(x,y:integer; factor:real; p : TSprite);
begin
  _scale1(x,y,
	  trunc(p.b*0.01*factor),
	  trunc(p.t*0.01*factor),p.b,p.t,
	  Ptr(seg(p.mem^),ofs(p.mem^)));
end;

{procedure, die fr _VIDEO13h.pas angepat wurde}
procedure PutSpriteScaledTrans(x,y,dx,dy:integer; col :word; p:TSprite);
begin
  TransparentColor := col;
  _scale1trans(x,y,dx,dy,p.b,p.t,Ptr(seg(p.mem^),ofs(p.mem^)));
end;

procedure PutSpritePerCentTrans(x,y:integer; factor:real; col:word; p : TSprite);
begin
  TransparentColor := col;
  _scale1trans(x,y,
	  trunc(p.b*0.01*factor),
	  trunc(p.t*0.01*factor),p.b,p.t,
	  Ptr(seg(p.mem^),ofs(p.mem^)));
end;


var
  t : string;

begin
 t := copyright;
end.
