{
  _XLSP10E.PAS 320x200x64K

  With this Unit you get the support of handling very large Sprites,
  named XLSprites.

  (c) vIRTUAL tECHNOLOGIES 1996

  Version 1.0a

  for more information, questions and register contact us:

    Ansgar Scherp
    scherp.ansgar@informatik.uni-oldenburg.de

    Joachim Gelhaus
    j.gelhaus@flight.gun.de

    http://www.informatik.uni-oldenburg.de/~virtech/

    Mailbox : + 49 (0) 4441 / 851887
    Hotline : + 49 (0) 4441 / 851717 (english, german)


  Remember, that in HiColor-Modes like 640x480x64K there are no longer
  any stuff like palettes. You can just put the color to the screen
  you want.

  If you already know our 256-Color units, you might miss the routines
  ending with 'eff'. They were totally renamed and don't have the
  appendix 'eff' longer.

}

{$IFNDEF DPMI}
...no, only for protected mode
{$ENDIF}


{DEFINE ShareWare}

unit _XLSP10E;

interface

uses _VidKRNL,crt,_VID10E;

const
  MaxSpriteParts = 50 { maximum number of sprites parts } - 1;


type
  TXLSprite =
    record
      SpritePart : array[ 0 .. MaxSpriteParts ] of TSprite;
      StartY     : array[ 0 .. MaxSpriteParts ] of word;
      Pages      : byte;
      t, b       : word;
      YDiv       : word;
     end;

{ initialise a XL-Sprite }
procedure InitXLSprite(VAR XLp : TXLSprite; b,t : word);

{ clear a XL-Sprite; fill with zero's }
procedure ClearXLSprite(VAR XLp : TXLSprite);

{ close a XL-Sprite; remove Sprite-memory }
procedure CloseXLSprite(VAR XLp : TXLSprite);

{ Loads a very large ( > 64kB ) Improces Clipboard-File as XL-Sprite }
procedure LoadXLImprocesCLB(name : string; VAR XLp : TXLSprite; pal : tPAL);

{ Loads a 16bit uncompressed TGA-File as XL-Sprite }
procedure LoadTGA2XLSprite(name : string; VAR p : TXLSprite);
{ Saves a XL-Sprite as 16bit uncompressed TGA-File }
procedure SaveXLSprite2TGA(name : string; VAR p : TXLSprite);

{ puts sprites to current active virtual screen }
procedure PutXLSpriteWindow10Eh(x,y:integer; var XLp:TXLSprite);
procedure PutXLSpriteWindowTrans10Eh(x,y:integer; trans:word; var XLp:TXLSprite);
procedure PutXLSpriteWindowShadow10Eh(x,y:integer; SubR, SubG, SubB : byte; XLp: TXLSprite );
procedure PutXLSpriteWindowLight10Eh(x,y:integer; AddR, AddG, AddB : byte; XLp: TXLSprite );
procedure PutXLSpriteWindowMix10Eh(x,y:integer; XLp: TXLSprite );

{ gets a XL-Sprite from current active virtual page }
procedure GetXLSpriteWindow10Eh(x,y:integer; var XLp:TXLSprite);

{ Puts or gets a Pixel to / from a XL-Sprite }
function  GetPixelfromXLSprite(x,y:longint; var XLp:TXLSprite):word;
procedure PutPixel2XLSprite(x,y:longint; var XLp:TXLSprite;c:word);

{ puts a Sprite into a XL-Sprite }
procedure PutSprite2XLSprite(x,y:integer;P:TSprite;XLp:TXLSprite);
procedure PutSprite2XLSpriteTrans(x,y:integer;trans:word;P:TSprite;XLp:TXLSprite);

{ puts a XL-Sprite into a "normal" Sprite }
procedure PutXLSprite2Sprite(x,y:integer;XLp:TXLSprite;P:TSprite);
procedure PutXLSprite2SpriteTrans(x,y:integer;trans:word;XLp:TXLSprite;P:TSprite);

{ puts a XL-Sprite into a XL-Sprite }
procedure PutXLSprite2XLSprite(x,y:integer;XLp,P:TXLSprite);
procedure PutXLSprite2XLSpriteTrans(x,y:integer;trans:word;XLp,P:TXLSprite);

{$IFNDEF ShareWare}
{ ONLY for registered users }
{ same like procedure wihtout Big; these are able to use the vIRtECH BigFileSystem }

{Hier sind die SCALING Routinen}
procedure PutXLSpriteScaled10Eh(x,y,dx,dy:integer; XLp: TXLSprite );
procedure PutXLSpritePerCent10Eh(x,y:integer; factor:real; XLp : TXLsprite);
procedure PutXLSpriteScaledTrans10Eh(x,y,dx,dy:integer; Tcol:word; XLp: TXLsprite );
procedure PutXLSpritePerCentTrans10Eh(x,y:integer; factor:real; Tcol:word; XLp : TXLSprite );

procedure BigLoadXLImprocesCLB(name : string; VAR XLp : TXLSprite; pal : tPAL; Files : byte);
procedure BigLoadTGA2XLSprite(name : string; VAR p : TXLSprite; files : byte);
{$ENDIF}

implementation

uses _DPMI{$IFNDEF ShareWare}, _BigLoad{$ENDIF};

procedure ClearXLSprite(VAR XLp : TXLSprite);
var
  pa : byte;
begin
  for pa := 0 to Xlp.Pages do
    begin
      ClearSprite( XLp.SpritePart[ pa ] );
    end;
end;

procedure InitXLSprite(VAR XLp : TXLSprite; b,t : word);
var
  tmp  : word;
  pa   : byte;
  YDiv : word;
begin
  XLp.b := b;
  XLp.t := t;
  for pa:=0 to MaxSpriteParts do
    XLp.SpritePart[pa].mem := NIL;

  { splitte die XL-Sprite in YDIV-Zeilen tiefe Sprite-Teile auf }
  YDiv := ( 64000 div 2 ) div b;
  XLp.YDiv := YDiv;

  with XLp do
    begin
      for pa := 0 to MaxSpriteParts do
        begin
          SpritePart[ pa ].mem := NIL;
          SpritePart[ pa ].b   := 0;
          SpritePart[ pa ].t   := 0;
          if t > pa * YDiv then
            begin
              Pages        := pa;
              StartY[ pa ] := pa * YDiv;
              tmp          := t - pa * YDiv;
              if tmp > YDiv then tmp := YDiv;
              SpritePart[ pa ].b := b;
              SpritePart[ pa ].t := tmp;
              GetMem( SpritePart[ pa ].mem, b * tmp * 2 );
            end;
        end;
    end;
end;

procedure CloseXLSprite(VAR XLp : TXLSprite);
var pa:byte;
begin
  with XLp do
    begin
      for pa:=0 to MaxSpriteParts do
        begin
          if ( SpritePart[ pa ].b * SpritePart[ pa ].t > 0 ) and
             ( SpritePart[ pa ].mem <> NIL ) then
            FreeMem( SpritePart[ pa ].mem,
                     SpritePart[pa].b * SpritePart[pa].t );
            SpritePart[ pa ].mem := nil;
            SpritePart[ pa ].b   := 0;
            SpritePart[pa].t     := 0;
            StartY[pa]           := 0;
        end;
      Pages := 0;
      t     := 0;
      b     := 0;
    end;
end;

procedure LoadXLImprocesCLB(name : string; VAR XLp : TXLSprite; pal : tPAL);
  const scan : string[5] = 'DIMS:';
  var f : file;
      t : string[5];
      b : word;
      h : word;
      x1,x2,y1,y2 : word;
      p : TSprite;
      tmp:word;
      pa:byte;
      buffer:pointer;
      bufseg, bufofs:word;
      pseg, pofs:word;
      x,y,c2:word;
      c1:byte;
      r1,g1,b1:word;

  procedure LoadNumber(VAR z : word);
    var Check : Integer;
  begin
    t := '';
    repeat
      blockread(f,b,1);
      if IOResult <> 0 then Video10EhError('"'+name+'" is not an IMPROCES-File.');
      if chr(b) <> ' ' then t := t + chr(b);
    until (chr(b) = ' ') or (Eof(f));
    Val(t,z,check);
    if Check <> 0 then video10Eherror('Error in loading IMPROCES-File.');
  end;


var
  YDiv : word;

begin
  if (XLp.SpritePart[0].mem<> NIL) and (XLp.b*XLp.t<>0) then
    Video10EhError('Trying to load a Sprite in an exiting one!('+name+')');
  {$I-}
  assign(f,name);
  reset(f,1);
  if IOResult <> 0 then video10Eherror('Error occurred when trying to load "'+name+'".');
  {}
  if filesize(f)-50 < 1 then seek(f,0) else seek(f,filesize(f)-50);
  t := '01234';
  repeat
    t[1] := t[2]; t[2] := t[3]; t[3] := t[4]; t[4] := t[5];
    blockread(f,t[5],1);
    if IOResult <> 0 then video10Eherror('"'+name+'" is not an IMPROCES-File.');
  until t = 'DIMS:';
  {$I+}
  LoadNumber(x1);
  LoadNumber(y1);
  LoadNumber(x2);
  LoadNumber(y2);
  XLp.b := x2 - x1 + 1;
  XLp.t := y2 - y1 + 1;

  { splitte die XL-Sprite in YDIV-Zeilen tiefe Sprite-Teile auf }
  YDiv := ( 64000 div 2 ) div XLp.b;
  XLp.YDiv := YDiv;

  seek(f,0);
  with XLp do
    begin
      for pa := 0 to MaxSpriteParts do
        begin
          if t > pa * YDiv then
            begin
              pages        := pa;
              StartY[ pa ] := pa * YDiv;
              tmp          := t - pa * YDiv;
              if tmp > YDiv then tmp := YDiv;
              SpritePart[ pa ].b := b;
              SpritePart[ pa ].t := tmp;
              GetMem( SpritePart[ pa ].mem, b * tmp * 2 );
              ClearSprite( SpritePart[ pa ] );
              GetMem( buffer, b * tmp );
              blockread( f, buffer^ , b * tmp );
              bufseg := seg( buffer^ );
              bufofs := ofs( buffer^ );
              pseg   := seg( SpritePart[ pa ].mem^ );
              pofs   := ofs( SpritePart[ pa ].mem^ );
              for y := 0 to tmp - 1 do
                begin
                  for x := 0 to b - 1 do
                    begin
                      c1 := mem[ bufseg : bufofs + y * b + x ];

                      r1 := pal.r[ c1 ];
                      g1 := pal.g[ c1 ];
                      b1 := pal.b[ c1 ];

                      r1 := r1 shr 1;
                      g1 := g1 shr 1;
                      b1 := b1 shr 1;

                      c2 := ( r1 shl 11 ) + ( g1 shl 6 ) + ( b1 );
                      if c1 = 0 then
                          c2 := 0
                        else
                          if c2 = 0 then
                            c2 := 1;
                      memw[ pseg : pofs ] := c2;
                      inc( pofs, 2 );
                    end;
                end;
              freemem( buffer, b * tmp );
            end;
        end;
    end;
  close(f);
end;

{$IFNDEF ShareWare}
procedure BigLoadXLImprocesCLB(name : string; VAR XLp : TXLSprite; pal : tPAL; Files : byte);
  const scan : string[5] = 'DIMS:';
  var t : string[5];
      b : word;
      h : word;
      x1,x2,y1,y2 : word;
      p : TSprite;
      tmp:word;
      pa:byte;
      buffer:pointer;
      bufseg, bufofs:word;
      pseg, pofs:word;
      x,y,c2:word;
      c1:byte;
      r1,g1,b1:word;
      nope:word;

  procedure LoadNumber(VAR z : word);
    var Check : Integer;
  begin
    t := '';
    repeat
      BigBlockread(files,b,1,nope);
      if IOResult <> 0 then Video10EhError('"'+name+'" is not an IMPROCES-File.');
      if chr(b) <> ' ' then t := t + chr(b);
    until (chr(b) = ' ') or (BigEof(files));
    Val(t,z,check);
    if Check <> 0 then video10Eherror('Error in loading IMPROCES-File.');
  end;

var
  YDiv : word;

begin
  if ( XLp.SpritePart[ 0 ].mem <> NIL ) and ( XLp.b * XLp.t <> 0 ) then
    Video10EhError('Trying to load a Sprite in an exiting one!('+name+')');
  {$I-}
  BigAssign(files,name);
  BigReset(files,1);
  if IOResult <> 0 then video10Eherror('Error occurred when trying to load "'+name+'".');
  {}
  if BigFilesize(files)-50 < 1 then BigSeek(files,0) else BigSeek(files,BigFilesize(files)-50);
  t := '01234';
  repeat
    t[1] := t[2]; t[2] := t[3]; t[3] := t[4]; t[4] := t[5];
    BigBlockread(files,t[5],1,nope);
    if IOResult <> 0 then video10Eherror('"'+name+'" is not an IMPROCES-File.');
  until t = 'DIMS:';
  {$I+}
  LoadNumber(x1);
  LoadNumber(y1);
  LoadNumber(x2);
  LoadNumber(y2);
  XLp.b := x2 - x1 + 1;
  XLp.t := y2 - y1 + 1;

  { splitte die XL-Sprite in YDIV-Zeilen tiefe Sprite-Teile auf }
  YDiv := ( 64000 div 2 ) div XLp.b;
  XLp.YDiv := YDiv;

  bigseek(files,0);
  with XLp do
    begin
      for pa := 0 to MaxSpriteParts do
        begin
          if t > pa * YDiv then
            begin
              Pages        := pa;
              StartY[ pa ] := pa * YDiv;
              tmp          := t - pa * YDiv;
              if tmp > YDiv then tmp := YDiv;
              SpritePart[ pa ].b := b;
              SpritePart[ pa ].t := tmp;
              GetMem( SpritePart[ pa ].mem, b * tmp * 2 );
              ClearSprite( SpritePart[ pa ] );
              GetMem( buffer, b * tmp );
              BigBlockread( files, buffer^, b * tmp, nope );

              bufseg := seg( buffer^ );
              bufofs := ofs( buffer^ );
              pseg := seg( SpritePart[ pa ].mem^ );
              pofs := ofs( SpritePart[ pa ].mem^ );
              for y := 0 to tmp - 1 do
                begin
                  for x := 0 to b - 1 do
                    begin
                      c1 := mem[ bufseg : bufofs + y * b + x ];
                      r1 := pal.r[ c1 ];
                      g1 := pal.g[ c1 ];
                      b1 := pal.b[ c1 ];

                      r1 := r1 shr 1;
                      g1 := g1 shr 1;
                      b1 := b1 shr 1;

                      c2 := ( r1 shl 11 ) + ( g1 shl 6 ) + ( b1 );
                      if c1 = 0 then c2 := 0 else
                        if c2 = 0 then c2 := 1;
                      memw[ pseg : pofs ] := c2;
                      inc( pofs, 2 );
                    end;
                end;
              freemem(buffer,b*tmp);
            end;
        end;
  end;
  BigClose(files);
end;
{$ENDIF}

procedure LoadTGA2XLSprite(name : string; VAR p : TXLSprite);
  var f : file;
      tgaHeader:TTGAHeader;
      buffer:pointer;
      bufferpos, bufferlength:word;
      realDataPos, realDataLength:longint;
      x,y,endx,endy:word;
      XLPage:byte;XLSpriteSeg,XLSpriteOfs:word;
      pbx2:word;
      datastart:word;
      w:word;
      r,g,b:byte;

  function getNextByte:byte;
  var r,g:word;
      b:byte;
  begin
    {Neue Daten von Platte einlesen}
    if bufferpos=bufferlength then begin
      if realDatapos+64000<realDataLength then r:=64000 else r:=realDataLength-realDataPos;
      blockread(f,buffer^,r,g);
      bufferpos:=0;
      bufferlength:=g;
    end;
    b:=mem[seg(buffer^):ofs(buffer^)+bufferpos];
    inc(bufferpos);
    inc(RealDataPos);
    getNextByte:=b;
  end;

var
  YDiv : word;

begin
  if (p.SpritePart[0].mem<> NIL) and (p.b*p.t<>0) then
    Video10EhError('Trying to load a Sprite in an exiting one!('+name+')');
  {$I-}
  assign(f,name);
  reset(f,1);
  if (IOResult <> 0) or (fileSize(f)<sizeof(TGAHeader))then Video10EhError('Error occurred when trying to load "'+name+'".');
  seek(f,0);
  blockread(f,TGAHeader,sizeOf(TGAHeader));
  if (TGAHeader.Resolution <> 16) then Video10EhError('"'+name+'" is not an 16 bit TGA-File.');
  if (TGAHeader.TARGAImageTyp<>2) then
    Video10EhError('"'+name+'" has a color table or is compressed. Please use the RGB model.');
  {$I+}
  p.b := TGAHeader.breite;
  p.t := TGAHeader.tiefe;

  InitXLSprite(p,p.b,p.t);

  clearXLSprite(p);

  with TGAHeader do begin
    datastart:=$12+laengeID+ColorMapTyp*ColorMapLength*(ColorMapEntrySize div 8);
    seek(f,datastart);
  end;

  getmem(buffer,64000); bufferlength:=0; bufferpos:=0;
  realdatalength:=filesize(f)-datastart; realdataPos:=0;
  pbx2:=P.b*2;
  endx:=(pbx2)-1; endy:=p.t-1;

  { splitte die XL-Sprite in YDIV-Zeilen tiefe Sprite-Teile auf }
  YDiv := ( 64000 div 2 ) div p.b;
  p.YDiv := YDiv;

  if TGAHeader.TARGAImageTyp = 2 then
    begin
      {unkomprimiert}
      for y := endy downto 0 do
        begin
          XLPage:=y div YDiv;
          XLSpriteSeg := seg( p.SpritePart[ XLPage ].mem^ );
          XLSpriteOfs := ofs( p.SpritePart[ XLPage ].mem^ ) +
                     ( y - p.starty[ XLPage ] ) * pbx2;
          for x:=0 to endx do
            begin
              mem[ XLSpriteSeg : XLSpriteOfs ] := getNextByte;
              inc( XLSpriteOfs );
            end;
          XLSpriteOfs := ofs( p.SpritePart[ XLPage ].mem^ ) +
                         ( y - p.starty[ XLPage ] ) * pbx2;
          for x:=0 to endx div 2 do
            begin
              w := memw[ XLSpriteSeg : XLSpriteOfs ];
              b := w and 31;
              w := w shr 5;
              g := w and 31;
              w := w shr 5;
              r := w and 31;
              w := ( r shl 11 ) + ( g shl 6 ) + b;
              memw[ XLSpriteSeg : XLSpriteOfs ] := w;
              inc( XLSpriteOfs, 2 );
            end;
        end;
    end;
  close( f );
  freemem( buffer, 64000 );
end;

{$IFNDEF ShareWare}
procedure BigLoadTGA2XLSprite(name : string; VAR p : TXLSprite; files : byte);
  var tgaHeader:TTGAHeader;
      buffer:pointer;
      bufferpos, bufferlength:word;
      realDataPos, realDataLength:longint;
      x,y,endx,endy:word;
      XLPage:byte;XLSpriteSeg,XLSpriteOfs:word;
      pbx2:word;
      datastart:word;
      w:word;
      r,g,b:byte;
      nope:word;

  function getNextByte:byte;
  var r,g:word;
      b:byte;
  begin
    {Neue Daten von Platte einlesen}
    if bufferpos=bufferlength then begin
      if realDatapos+64000<realDataLength then r:=64000 else r:=realDataLength-realDataPos;
      BigBlockread(files,buffer^,r,g);
      bufferpos:=0;
      bufferlength:=g;
    end;
    b:=mem[seg(buffer^):ofs(buffer^)+bufferpos];
    inc(bufferpos);
    inc(RealDataPos);
    getNextByte:=b;
  end;

var
  YDiv : word;

begin
  if ( p.SpritePart[ 0 ].mem <> NIL ) and ( p.b * p.t <> 0 ) then
    Video10EhError('Trying to load a Sprite in an exiting one!('+name+')');
  {$I-}
  BigAssign(files,name);
  BigReset(files,1);
  if (IOResult <> 0) or (BigFileSize(files)<sizeof(TGAHeader)) then
    Video10EhError('Error occurred when trying to load "'+name+'".');
  BigSeek(files,0);
  BigBlockread(files,TGAHeader,sizeOf(TGAHeader),nope);
  if (TGAHeader.Resolution <> 16) then Video10EhError('"'+name+'" is not an 16 bit TGA-File.');
  if (TGAHeader.TARGAImageTyp<>2) then
    Video10EhError('"'+name+'" has a color table or is compressed. Please use the RGB model.');
  {$I+}
  p.b := TGAHeader.breite;
  p.t := TGAHeader.tiefe;
  InitXLSprite(p,p.b,p.t);
  clearXLSprite(p);
  with TGAHeader do begin
    datastart:=$12+laengeID+ColorMapTyp*ColorMapLength*(ColorMapEntrySize div 8);
    BigSeek(files,datastart);
  end;
  getmem(buffer,64000); bufferlength:=0; bufferpos:=0;
  realdatalength:=BigFilesize(files)-datastart; realdataPos:=0;
  pbx2:=P.b*2;
  endx:=(pbx2)-1; endy:=p.t-1;

  { splitte die XL-Sprite in YDIV-Zeilen tiefe Sprite-Teile auf }
  YDiv := ( 64000 div 2 ) div p.b;
  p.YDiv := YDiv;

  if TGAHeader.TARGAImageTyp = 2 then
    begin
      {unkomprimiert}
      for y := endy downto 0 do
        begin
          XLPage := y div YDiv;
          XLSpriteSeg := seg( p.SpritePart[ XLPage ].mem^ );
          XLSpriteOfs := ofs( p.SpritePart[ XLPage ].mem^ ) +
                     ( y - p.starty[ XLPage ] ) * pbx2;

          for x := 0 to endx do
            begin
              mem[ XLSpriteSeg : XLSpriteOfs ] := getNextByte;
              inc( XLSpriteOfs );
            end;
          XLSpriteOfs := ofs( p.SpritePart[ XLPage ].mem^ ) +
                         ( y - p.StartY[ XLPage ] ) * pbx2;
          for x:=0 to endx div 2 do
            begin
              w := memw[ XLSpriteSeg : XLSpriteOfs ];
              b := w and 31; w := w shr 5;
              g := w and 31; w := w shr 5;
              r := w and 31;
              w := ( r shl 11 ) + ( g shl 6 ) + b;
              memw[ XLSpriteSeg : XLSpriteOfs] := w;
              inc( XLSpriteOfs, 2 );
            end;
        end;
  end;
  BigClose( files );
  freemem( buffer, 64000 );
end;
{$ENDIF}

procedure SaveXLSprite2TGA(name : string; VAR p : TXLSprite);
  var f : file;
      tgaHeader:TTGAHeader;
      buffer:pointer;
      bufferpos,bufferlength:word;
      w:word;
      r,g,b:word;
      y,endy:word;
      pbx2:word;
      CreateLine:string[80];
      XLPage:byte;XLSpriteSeg,XLSpriteOfs:word;
begin
  if p.SpritePart[0].mem = NIL then
    Video10EhError('Trying to save a no  existing Sprite!');
  {$I-}
  assign(f,name);
  rewrite(f,1);
  if (IOResult <> 0) then Video10EhError('Error occurred when trying to save "'+name+'".');
  with TGAHeader do begin
    LaengeID         :=0;
    ColorMapTyp      :=0;
    TARGAImageTyp    :=2;
    ColorMapOffset   :=0;
    ColorMapLength   :=0;
    ColorMapEntrySize:=0;
    StartX           :=0;
    StartY           :=0;
    Breite           :=p.b;
    Tiefe            :=p.t;
    Resolution       :=16;
    ImageDescription :=01;
  end;
  blockwrite(f,TGAHeader,sizeOf(TGAHeader));
  seek(f, filepos(f)  -1);
  {$I+}
  pbx2 := p.b * 2;
  endy := p.t - 1;
  {unkomprimiert}
  for y := endy downto 0 do begin
    XLPage := y div p.YDiv;
    XLSpriteSeg := seg( p.SpritePart[ XLPage ].mem^ );
    XLSpriteOfs := ofs( p.SpritePart[ XLPage ].mem^ ) +
                   ( y - p.starty[XLPage] ) * pbx2;
    bufferlength := pbx2;
    getmem( buffer, bufferlength );
    for bufferpos := 0 to p.b - 1 do
      begin
      w:=memw[XLSpriteSeg:XLSpriteOfs+bufferpos*2];
      b:=w and 31; w:=w shr 6;
      g:=w and 31; w:=w shr 5;
      r:=w and 31;
      w:=(r shl 10) or (g shl 5) or b;
      memw[seg(buffer^):ofs(buffer^)+bufferpos*2]:=w;
    end;
    blockwrite(f,buffer^,bufferlength);
    freemem(buffer,bufferlength);
  end;
  CreateLine:='created with vIRTECH gamedeveloper kit';
  blockwrite(f,createline,length(createline)+1);
  close(f);
end;

procedure PutXLSpriteWindow10Eh( x, y : integer; var XLp : TXLSprite );
var
  pa : byte;
begin
  for pa := 0 to Xlp.Pages do
    begin
      PutSpriteWindow10Eh( x, y + XLp.StartY[ pa ], XLp.SpritePart[ pa ] );
    end;
end;

procedure PutXLSpriteWindowTrans10Eh( x, y : integer; trans : word;
                                      var XLp : TXLSprite );
var
  pa : byte;
begin
  for pa := 0 to Xlp.Pages do
    begin
      PutSpriteWindowTrans10Eh(x,y+XLp.StartY[pa],trans,XLp.SpritePart[pa]);
    end;
end;

procedure PutXLSpriteWindowShadow10Eh(x,y:integer; SubR, SubG, SubB : byte; XLp: TXLSprite );
var pa:byte;
begin
  for pa:=0 to Xlp.Pages do begin
    PutSpriteWindowShadow10Eh(x,y+XLp.StartY[pa], SubR, SubG, SubB, XLp.SpritePart[pa]);
  end;
end;

procedure PutXLSpriteWindowLight10Eh(x,y:integer; AddR, AddG, AddB : byte; XLp: TXLSprite );
var pa:byte;
begin
  for pa:=0 to Xlp.Pages do begin
    PutSpriteWindowLight10Eh(x,y+XLp.StartY[pa], AddR, AddG, AddB, XLp.SpritePart[pa]);
  end;
end;

procedure PutXLSpriteWindowMix10Eh(x,y:integer; XLp: TXLSprite );
var pa:byte;
begin
  for pa:=0 to Xlp.Pages do begin
    PutSpriteWindowMix10Eh(x,y+XLp.StartY[pa], XLp.SpritePart[pa]);
  end;
end;


procedure GetXLSpriteWindow10Eh(x,y:integer; var XLp:TXLSprite);
var pa:byte;
begin
  for pa:=0 to Xlp.Pages do begin
    GetSprite10Eh(x,y+XLp.StartY[pa],XLp.SpritePart[pa]);
  end;
end;

function GetPixelfromXLSprite(x,y:longint; var XLp:TXLSprite):word;
var pa:integer;
    c:word;
begin
  pa:=XLp.pages+1;
  repeat
    dec(pa);
    if (XLp.StartY[pa]<=y) then begin
      c:=GetPixelfromSprite(x,y-XLp.StartY[pa],XLp.SpritePart[pa]);
    end;
  until (XLp.StartY[pa]<=y) or (0=pa);
  GetPixelfromXLSprite:=c;
end;

procedure PutPixel2XLSprite(x,y:longint; var XLp:TXLSprite;c:word);
var pa:integer;
begin
  pa:=XLp.pages+1;
  repeat
    dec(pa);
    if (XLp.StartY[pa]<=y) then begin
      PutPixel2Sprite(XLp.SpritePart[pa],x,y-XLp.StartY[pa],c);
    end;
  until (XLp.StartY[pa]<=y) or (0=pa);
end;

procedure PutSprite2XLSprite(x,y:integer;P:TSprite;XLp:TXLSprite);
var pa:byte;
begin
  for pa:=0 to Xlp.Pages do begin
    PutSprite2Sprite(x,y-XLp.StartY[pa],p,XLp.SpritePart[pa]);
  end;
end;

procedure PutSprite2XLSpriteTrans(x,y:integer;trans:word;P:TSprite;XLp:TXLSprite);
var pa:byte;
begin
  for pa:=0 to Xlp.Pages do begin
    PutSprite2SpriteTrans(x,y-XLp.StartY[pa],trans,p,XLp.SpritePart[pa]);
  end;
end;

procedure PutXLSprite2Sprite(x,y:integer;XLp:TXLSprite;P:TSprite);
var pa:byte;
begin
  for pa:=0 to Xlp.Pages do begin
    PutSprite2Sprite(x,y+XLp.StartY[pa],XLp.SpritePart[pa],p);
  end;
end;

procedure PutXLSprite2SpriteTrans(x,y:integer;trans:word;XLp:TXLSprite;P:TSprite);
var pa:byte;
begin
  for pa:=0 to Xlp.Pages do begin
    PutSprite2SpriteTrans(x,y+XLp.StartY[pa],trans,XLp.SpritePart[pa],p);
  end;
end;

procedure PutXLSprite2XLSprite(x,y:integer;XLp,P:TXLSprite);
var pa:byte;
begin
  for pa:=0 to Xlp.Pages do begin
    PutSprite2XLSprite(x,y+XLp.StartY[pa],XLp.SpritePart[pa],p);
  end;
end;

procedure PutXLSprite2XLSpriteTrans(x,y:integer;trans:word;XLp,P:TXLSprite);
var pa:byte;
begin
  for pa:=0 to Xlp.Pages do begin
    PutSprite2XLSpriteTrans(x,y+XLp.StartY[pa],trans,XLp.SpritePart[pa],p);
  end;
end;

{$IFNDEF SHAREWARE}
{Hier sind die SCALING Routinen}
procedure PutXLSpriteScaled10Eh(x,y,dx,dy:integer; XLp: TXLSprite );
var
  pa     : byte;
  StartY : array[ 0 .. MaxSpriteParts ] of word;
  dynew  : word;
begin
  dynew := dy DIV ( XLp.t DIV XLp.YDiv );
  for pa := 0 to XLp.Pages do
    begin
      StartY[ pa ] := round( XLp.StartY[ pa ] / ( XLp.YDiv / dynew ) );
    end;
  for pa := 0 to XLp.Pages do
    begin
      PutSpriteScaled10Eh( x, y + StartY[ pa ], dx, dynew, XLp.SpritePart[pa] );
    end;
end;

procedure PutXLSpritePerCent10Eh(x,y:integer; factor:real; XLp : TXLsprite);
var
  pa     : byte;
  StartY : array[ 0 .. MaxSpriteParts ] of word;
begin
  for pa := 0 to XLp.Pages do
    begin
      StartY[ pa ] := trunc( XLp.StartY[ pa ] * factor * 0.01 );
    end;
  for pa := 0 to XLp.Pages do
    begin
      PutSpritePerCent10Eh( x, y + StartY[ pa ], factor, XLp.SpritePart[pa] );
    end;
end;

procedure PutXLSpriteScaledTrans10Eh(x,y,dx,dy:integer; Tcol:word; XLp: TXLsprite );
var
  pa     : byte;
  StartY : array[ 0 .. MaxSpriteParts ] of word;
  dynew  : word;
begin
  dynew := dy DIV ( XLp.t DIV XLp.YDiv );
  for pa := 0 to XLp.Pages do
    begin
      StartY[ pa ] := round( XLp.StartY[ pa ] / ( XLp.YDiv / dynew ) );
    end;
  for pa := 0 to XLp.Pages do
    begin
      PutSpriteScaledTrans10Eh( x, y + StartY[ pa ], dx, dynew, Tcol, XLp.SpritePart[pa] );
    end;
end;

procedure PutXLSpritePerCentTrans10Eh(x,y:integer; factor:real; Tcol:word; XLp : TXLSprite );
var
  pa     : byte;
  StartY : array[ 0 .. MaxSpriteParts ] of word;
begin
  for pa := 0 to XLp.Pages do
    begin
      StartY[ pa ] := trunc( XLp.StartY[ pa ] * factor * 0.01 );
    end;
  for pa := 0 to XLp.Pages do
    begin
      PutSpritePerCentTrans10Eh( x, y + StartY[ pa ], factor, TCol, XLp.SpritePart[pa] );
    end;
end;

{$ENDIF}

begin
end.